#define MU 1.05
#include "hif_main.h"
#include "hif_classes.h"
#include "images.h"
#include <stdlib.h>
#include <math.h>
#include "sound.h"
#include "log.h"
#define SQR(x) ((x)*(x))
#define SAVEFIELD(q) BZ2_bzwrite(f,&q,sizeof(q))
#define GETFIELD(q) BZ2_bzread(f,&q,sizeof(q))
Sint16 *CHIF_Drop::get_info(Sint16 *t)
{
x=*t++;y1=*t++;y2=*t++;is_falling=1;delta=*t++;damage=*t++;phase=0;return t;
}
void CHIF_Drop::init(Uint16 x_,Uint16 y1_,Uint16 y2_,char delta_,char damage_)
{
x=x_;y1=y1_;y2=y2_;phase=0;delta=delta_;damage=damage_;is_falling=1;
}
void CHIF_Drop::refresh(int x0,int y0)
{
if((phase<y2-y1)&&(is_falling==1)){
  SDL_Rect r1={x-x0-1,phase+y1-y0,3,1},r2={x-x0-1,phase+y1-y0+1,3,1};
  HIF_FillRect(screen,&r1,SDL_MapRGB(screen->format,180,70,180));
  HIF_FillRect(screen,&r2,SDL_MapRGB(screen->format,10,240,10));};
}
void CHIF_Drop::proceed(void)
{
phase=(phase+4)%(y2-y1+2+delta);
  if (phase<4){is_falling=1;};
if ((phase<y2-y1)&&(is_falling==1)&&
    (hif_player_info.x+hif_sizes[hif_player_info.size][0]<=x)&&(is_falling==1)&&(hif_player_info.x+hif_sizes[hif_player_info.size][2]>=x)&&
    (hif_player_info.y+hif_sizes[hif_player_info.size][1]<=phase+y1)&&(hif_player_info.y+hif_sizes[hif_player_info.size][3]>=phase+y1))
        {hif_player_info.health-=damage;hif_add_text(25,-25,_LOCALE_HIF_DAMAGED_BY_DROP);is_falling=0;hif_to_update_panel=1;};
}
void CHIF_Drop::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y1);SAVEFIELD(y2);SAVEFIELD(phase);SAVEFIELD(delta);SAVEFIELD(damage);SAVEFIELD(is_falling);
}
void CHIF_Drop::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y1);GETFIELD(y2);GETFIELD(phase);GETFIELD(delta);GETFIELD(damage);GETFIELD(is_falling);
}
void CHIF_Thing::refresh(int x0,int y0)
{
SDL_Rect r2={type*5,5*(is_hurting%2),5,5},r1={(int)x-2-x0,(int)y-2-y0,5,5},r3={(int)x-x0+5,(int)y-y0-5,no,1},r4={r3.x,r3.y+1,r3.w,1};
if ((type>=5)&&(type<=9)){if (abs((int)vx)>abs((int)vy)){if (vx<0)r2.y+=20;}else{if (vy>0){r2.y+=30;}else{r2.y+=10;};};};
HIF_BlitStdSurface(_IMG_hif_things,&r2,&r1);if (SQR(x-hif_player_info.x)+SQR(y-hif_player_info.y)<SQR(HIF_INFO_DIST)){
  HIF_FillRect(screen,&r3,SDL_MapRGB(screen->format,0,100,0));
  HIF_FillRect(screen,&r4,SDL_MapRGB(screen->format,0,155,0));};
}
int CHIF_Thing::proceed(void)
{
int hif_offs,i2;
char gets_thing,is_moving=0;
float dx,dy;
if (hif_proceed_can_thing(x,y)==-1){x-=1.0;if (hif_proceed_can_thing(x,y)!=0){x+=2.0;if (hif_proceed_can_thing(x,y)!=0){
                            x-=1.0;y-=1.0;if (hif_proceed_can_thing(x,y)!=0){y+=2.0;if (hif_proceed_can_thing(x,y)!=0){y-=1.0;};};};};};
if (abs((int)vx)>=39)vx=SGN(vx)*38;if (abs((int)vy)>=39)vy=SGN(vy)*38;if ((is_hurting%2==0)&&(vy<0)){vy/=1.5;};
if (hif_proceed_can_thing(x+vx,y)!=0){is_hurting&=2;vx=vy=0;if (hif_proceed_can_thing(x+SGN(vx),y)==0){dx=SGN(vx);}else{dx=0;};}else{dx=vx;};
if (hif_proceed_can_thing(x,y+vy)!=0){is_hurting&=2;vx=vy=0;if (hif_proceed_can_thing(x,y+SGN(vy))==0){dy=SGN(vy);}else{dy=0;};}else{dy=vy;};
for (i2=0;i2<hif_level_info.numblocks_real;i2++)
  if ((MAX(hif_level_info.blocks[i2].x1,MIN(x,x+vx))<MIN(hif_level_info.blocks[i2].x2,MAX(x,x+vx)))&&
       (MAX(hif_level_info.blocks[i2].y1,MIN(y,y+vy))<MIN(hif_level_info.blocks[i2].y2,MAX(y,y+vy)))){dx=dy=0;break;};
x+=dx;y+=dy;
if (is_hurting==2){vx=vy=0;
  if (hif_proceed_can_thing(x,y+SGN(hif_player_info.y-y))==0)y+=SGN(hif_player_info.y-y);
  if (hif_proceed_can_thing(x+SGN(hif_player_info.x-x),y)==0)x+=SGN(hif_player_info.x-x);};
hif_offs=0;//vents
for (i2=0;i2<hif_level_info.numvents;i2++)if((hif_level_info.vents[i2].x<=x+2)&&(hif_level_info.vents[i2].y<=y+2)&&
    (hif_level_info.vents[i2].x+hif_level_info.vents[i2].xs>=x-2)&&(hif_level_info.vents[i2].y+hif_level_info.vents[i2].ys>=y-2)){
    int t=(int)(hif_level_info.vents[i2].v*
  (1+MIN(hif_level_info.vents[i2].x+hif_level_info.vents[i2].xs,x+2)-MAX(hif_level_info.vents[i2].x,x-2))*
  (1+MIN(hif_level_info.vents[i2].y+hif_level_info.vents[i2].ys,y+2)-MAX(hif_level_info.vents[i2].y,y-2)));hif_offs+=t;if (t!=0)is_moving=1;};
if (hif_proceed_can_thing(x,y-(float)hif_offs/25.0)==0){y-=(float)hif_offs/25.0;} else
 if (hif_proceed_can_thing(x,y-SGN(hif_offs))==0){y-=SGN(hif_offs);};
hif_offs=0;//rivers
for (i2=0;i2<hif_level_info.numrivers;i2++)if((hif_level_info.rivers[i2].x<=x+2)&&(hif_level_info.rivers[i2].y<=y+2)&&
    (hif_level_info.rivers[i2].x+hif_level_info.rivers[i2].xs>=x-2)&&(hif_level_info.rivers[i2].y+hif_level_info.rivers[i2].ys>=y-2))
  {int t=(int)(hif_level_info.rivers[i2].v*
  (1+MIN(hif_level_info.rivers[i2].x+hif_level_info.rivers[i2].xs,x+2)-MAX(hif_level_info.rivers[i2].x,x-2))*
  (1+MIN(hif_level_info.rivers[i2].y+hif_level_info.rivers[i2].ys,y+2)-MAX(hif_level_info.rivers[i2].y,y-2)));hif_offs+=t;if (t!=0)is_moving=1;};
if (hif_proceed_can_thing(x-(float)hif_offs/25.0,y)==0){x-=(float)hif_offs/25.0;} else
 if (hif_proceed_can_thing(x-SGN(hif_offs),y)==0){x-=SGN(hif_offs);};
if (is_hurting==0){//non-hurting thing falls and gets slower on the floor
if ((hif_proceed_can_thing(x,y+3)==0)){y+=3;}else{if (hif_proceed_can_thing(x,y+1)==0){y++;}else{vx/=MU;};};};
if ((x>=hif_player_info.x-3+hif_sizes[hif_player_info.size][0])&&(y>=hif_player_info.y-3+hif_sizes[hif_player_info.size][1])&&
  (x<=hif_player_info.x+3+hif_sizes[hif_player_info.size][2])&&(y<=hif_player_info.y+3+hif_sizes[hif_player_info.size][3]))
    {gets_thing=0;//thing with hendehoh
switch(type){
case HIF_THING_DOT:gets_thing=1;break;
case HIF_THING_REDKEY:case HIF_THING_GREENKEY:case HIF_THING_BLUEKEY:
  if (hif_player_info.size!=3){hif_player_info.keys[type-HIF_THING_REDKEY]+=no;
  hif_to_update_panel=1;hif_add_text(25,-25,_LOCALE_HIF_TOOK_KEY);gets_thing=1;};break;
case HIF_THING_COLA:if (hif_player_info.size!=3){hif_player_info.health+=5*no;hif_to_update_panel=1;
  hif_add_text(25,-25,_LOCALE_HIF_TOOK_FOOD);gets_thing=1;};break;
case HIF_THING_FOOD:if (hif_player_info.size!=3){hif_player_info.health+=15*no;hif_to_update_panel=1;
  hif_add_text(25,-25,_LOCALE_HIF_TOOK_FOOD);gets_thing=1;};break;
case HIF_THING_COIN:if (hif_player_info.size!=3){hif_add_text(25,-25,_LOCALE_HIF_GETS_COIN);gets_thing=1;
    hif_player_info.scores+=no;};break;
case HIF_THING_PREBEER:if (hif_player_info.size!=3){hif_player_info.num_prebeer+=no;gets_thing=1;
    hif_to_update_panel=1;hif_add_text(25,-25,_LOCALE_HIF_TOOK_PREBEER);};break;
case HIF_THING_TRAP:case HIF_THING_TRAPMINE:hif_add_text(25,-25,_LOCALE_HIF_HURTED);gets_thing=1;
  hif_to_update_panel=1;hif_player_info.health-=no*HIF_TRAP_DAMAGE;if (type==HIF_THING_TRAPMINE)hif_player_info.weapons[7]+=no;break;
case HIF_THING_TRAPOFFMINE:if (hif_player_info.size!=3){
  gets_thing=1;hif_add_text(25,-25,LOCALE_HIF_FIRSTSHELL+5);hif_add_text(25,-18,LOCALE_HIF_FIRSTSHELL+6);
  hif_player_info.weapons[6]+=no;hif_player_info.weapons[7]+=no;};break;
case HIF_THING_FIRSTSHELL:case HIF_THING_FIRSTSHELL+1:case HIF_THING_FIRSTSHELL+2:case HIF_THING_FIRSTSHELL+3:
case HIF_THING_FIRSTSHELL+4:case HIF_THING_FIRSTSHELL+6:case HIF_THING_FIRSTSHELL+7:case HIF_THING_TRAPOFF:
if (is_hurting%2==0){if (hif_player_info.size!=3){if (type==HIF_THING_TRAPOFF){hif_player_info.weapons[6]+=no;gets_thing=1;
hif_add_text(25,-20,LOCALE_HIF_FIRSTSHELL+5);} else {
hif_player_info.weapons[1+type-HIF_THING_FIRSTSHELL]+=no;hif_add_text(25,-20,LOCALE_HIF_FIRSTSHELL+type-HIF_THING_FIRSTSHELL);
gets_thing=1;};};
} else {hif_player_info.health-=hif_weapon_damages[type-HIF_THING_FIRSTSHELL]*no;hif_to_update_panel=1;
    hif_add_text(25,-25,_LOCALE_HIF_HURTED);gets_thing=1;};hif_to_update_panel=1;break;
};
if ((gets_thing==1)&&(hif_level_info.numscth!=HIF_NUM_SCTH))hif_level_info.scth[hif_level_info.numscth++].init((int)x,(int)y,_IMG_hif_things,
      type*5,5*(is_hurting%2),5,5);
if (gets_thing==1){return -1;};
};
if (is_hurting==0){vy=0;if (fabs(vx)<0.01)vx=0;};
is_resting=((type!=HIF_THING_TRAP)&&(type!=HIF_THING_TRAPMINE)&&(is_hurting==0)&&(is_moving==0)&&
    (hif_proceed_can_thing(x,y+1)==-1)&&(type!=HIF_THING_FIRSTSHELL+6))?(1):(0);
if ((type==HIF_THING_DOT)&&(is_hurting!=1)){return -1;}else{return 0;};
}
void CHIF_Thing::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(vx);SAVEFIELD(vy);SAVEFIELD(no);SAVEFIELD(type);SAVEFIELD(is_hurting);SAVEFIELD(is_lonely);
}
void CHIF_Thing::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(vx);GETFIELD(vy);GETFIELD(no);GETFIELD(type);GETFIELD(is_hurting);GETFIELD(is_lonely);
}
void CHIF_Vent::init(Uint16 x_,Uint16 y_,char v_)
{
x=x_;y=y_;v=v_;phase=0;
}
void CHIF_Vent::refresh(int x0,int y0,SDL_Surface *s)
{
SDL_Rect r1={0,phase,xs,ys-phase},r2={x-x0,y-y0,xs,ys-phase},r3={0,0,s->w,phase},r4={x-x0,y-y0+ys-phase,xs,phase};
HIF_BlitSurface(s,&r1,screen,&r2);HIF_BlitSurface(s,&r3,screen,&r4);
}
void CHIF_Vent::proceed()
{
    phase+=v+xs;phase%=ys;
if ((y<=hif_player_info.y+hif_sizes[hif_player_info.size][3])&&
     (y+ys>=hif_player_info.y+hif_sizes[hif_player_info.size][1])&&
     (x<=hif_player_info.x+hif_sizes[hif_player_info.size][2])&&
     (x+xs>=hif_player_info.x+hif_sizes[hif_player_info.size][0]))
 {hif_player_info.vent_offs-=v*
      (MIN(hif_player_info.x+hif_sizes[hif_player_info.size][2],x+xs)-MAX(hif_player_info.x+hif_sizes[hif_player_info.size][0],x))*
      (MIN(hif_player_info.y+hif_sizes[hif_player_info.size][3],y+ys)-MAX(hif_player_info.y+hif_sizes[hif_player_info.size][1],y));
  if (hif_player_info.vy>0){hif_player_info.vy=0;};
  hif_player_info.in_vent=1;};
}
void CHIF_Vent::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(xs);SAVEFIELD(ys);SAVEFIELD(phase);SAVEFIELD(v);
}
void CHIF_Vent::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(xs);GETFIELD(ys);GETFIELD(phase);GETFIELD(v);
}
void CHIF_River::init(Uint16 x_,Uint16 y_,char v_)
{
x=x_;y=y_;v=v_;phase=0;
}
void CHIF_River::refresh(int x0,int y0,SDL_Surface *s)
{
SDL_Rect r1={phase,0,xs-phase,ys},r2={x-x0,y-y0,xs-phase,ys},r3={0,0,phase,ys},r4={x-x0+xs-phase,y-y0,phase,ys};
if ((xs!=0)&&(ys!=0)){HIF_BlitSurface(s,&r1,screen,&r2);HIF_BlitSurface(s,&r3,screen,&r4);};
}
void CHIF_River::proceed(void)
{
if ((xs==0)||(ys==0))return;
phase+=v+(xs);phase%=(xs);
if ((y<hif_player_info.y+hif_sizes[hif_player_info.size][3])&&(y+ys>hif_player_info.y+hif_sizes[hif_player_info.size][1])&&
     (x<hif_player_info.x+hif_sizes[hif_player_info.size][2])&&(x+xs>hif_player_info.x+hif_sizes[hif_player_info.size][0])){
  hif_player_info.river_offs-=v*
  (MIN(hif_player_info.y+hif_sizes[hif_player_info.size][3],y+ys)-MAX(hif_player_info.y+hif_sizes[hif_player_info.size][1],y))*
  (MIN(hif_player_info.x+hif_sizes[hif_player_info.size][2],x+xs)-MAX(hif_player_info.x+hif_sizes[hif_player_info.size][0],x));};
if((x<=hif_player_info.x+(2*hif_player_info.direction-1)*hif_nose[hif_player_info.size][0])&&
  (y<=hif_player_info.y+hif_nose[hif_player_info.size][1])&&
  (x+xs>=hif_player_info.x+(2*hif_player_info.direction-1)*hif_nose[hif_player_info.size][0])&&
  (y+ys>=hif_player_info.y+hif_nose[hif_player_info.size][1]))hif_player_info.in_river=1;
}
void CHIF_River::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(xs);SAVEFIELD(ys);SAVEFIELD(phase);SAVEFIELD(v);
}
void CHIF_River::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(xs);GETFIELD(ys);GETFIELD(phase);GETFIELD(v);
}
void CHIF_Fireball::init(float _x,float _y,float _direction)
{
x=_x;y=_y;direction=_direction;hang=0;phase=0;
}
void CHIF_Fireball::refresh(int x0,int y0)
{
SDL_Rect r1={(int)x-1-x0,(int)y-1-y0,3,3},r2={phase*3,0,3,3};
HIF_BlitStdSurface(_IMG_hif_fireball,&r2,&r1);
}
int CHIF_Fireball::proceed(void)
{
int i2;
if (hang==0){x+=3.5*sin(direction);y+=3.5*cos(direction);};//just move
if (hif_proceed_smb_cango((int)x,(int)y,-1,-1,1,1)==-1){if (phase==0)phase=1;hang=1;};
if (phase==0){
  if  ((MAX(hif_player_info.x+hif_sizes[hif_player_info.size][0],x-1)<MIN(hif_player_info.x+hif_sizes[hif_player_info.size][2],x+1))&&//with hendehoh
      (MAX(hif_player_info.y+hif_sizes[hif_player_info.size][1],y-1)<MIN(hif_player_info.y+hif_sizes[hif_player_info.size][3],y+1)))
        {hif_player_info.health-=HIF_FIREBALL_DAMAGE;hif_add_text(25,-10,_LOCALE_HIF_HURTED);hif_to_update_panel=1;
          phase=1;if (hif_player_info.t_drank<4*HIF_DRANK_QUATER)hif_player_info.t_drank+=8;};
 for (i2=0;i2<hif_level_info.numenemies;i2++)if (hif_level_info.enemies[i2]->health!=0)//with enemies
  if  ((MAX(hif_level_info.enemies[i2]->x+HIF_ENEMY_SIZE(i2,0),x-1)<MIN(hif_level_info.enemies[i2]->x+HIF_ENEMY_SIZE(i2,2),x+1))&&
      (MAX(hif_level_info.enemies[i2]->y+HIF_ENEMY_SIZE(i2,1),y-1)<MIN(hif_level_info.enemies[i2]->y+HIF_ENEMY_SIZE(i2,3),y+1)))
      {phase=1;hif_level_info.enemies[i2]->health=
                (hif_level_info.enemies[i2]->health>HIF_FIREBALL_DAMAGE)?(hif_level_info.enemies[i2]->health-HIF_FIREBALL_DAMAGE):(0);};
 for (i2=0;i2<hif_level_info.numrivers;i2++)
  if  ((MAX(hif_level_info.rivers[i2].x,x-1)<MIN(hif_level_info.rivers[i2].x+hif_level_info.rivers[i2].xs,x+1))&&
      (MAX(hif_level_info.rivers[i2].y,y-1)<MIN(hif_level_info.rivers[i2].y+hif_level_info.rivers[i2].ys,y+1)))phase=1;
};
if (phase!=0){phase++;if (phase>HIF_FIREBALL_NUMPHASES)return (-1);};//changing phase
return 0;
}
void CHIF_Fireball::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(direction);SAVEFIELD(phase);SAVEFIELD(hang);
}
void CHIF_Fireball::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(direction);GETFIELD(phase);GETFIELD(hang);
}
void CHIF_Bee::init(int x_,int y_)
{
x=x_;y=y_;enabled=1;beer=HIF_BEE_MAXBEER;state=HIF_BEE_DRINKING;ph_left=HIF_BEE_DRINKING_;
hif_level_info.bee.direction=(rand()%360)*PI/180.0;is_right=rand()%2;beer_line=40;
}
void CHIF_Bee::refresh(int x0,int y0)
{
if (enabled==1){
int x2=(int)x-HIF_BEE_HALFXSIZE-x0,y2=(int)y-HIF_BEE_HALFYSIZE-y0;
SDL_Rect r1,r2;
switch (state){
case HIF_BEE_BREATHING:case HIF_BEE_RISING:case HIF_BEE_FLYING:case HIF_BEE_PREROTATING:case HIF_BEE_DRINKING:
ASSIGNRECT(r1,x2+5*(1-is_right),y2,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);
ASSIGNRECT(r2,30*(hif_ticks%4),0,30,15);HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);
ASSIGNRECT(r1,x2+7*is_right,y2+14,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);
ASSIGNRECT(r2,0,15,23,8);HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);
ASSIGNRECT(r1,x2+17*is_right,y2,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);
ASSIGNRECT(r2,13*(hif_ticks%4),23,13,15);
HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);
if (state==HIF_BEE_DRINKING){int part=1+13*ph_left/HIF_BEE_DRINKING_;
ASSIGNRECT(r1,106,23+14-part,13,part);ASSIGNRECT(r2,x2+((is_right==0)?(1):(2*HIF_BEE_HALFXSIZE-13)),y2+8+14-part,13,part);
HIF_BlitStdSurface(HIF_BEE_IMAGE,&r1,&r2);
};
break;
case HIF_BEE_DYING:case HIF_BEE_FALLING:
ASSIGNRECT(r1,x2,y2,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);ASSIGNRECT(r2,27*(hif_ticks%3),38,27,22);
HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);break;
case HIF_BEE_OVERTURNING:
ASSIGNRECT(r1,x2,y2,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);
ASSIGNRECT(r2,(int)(27*floor(((HIF_BEE_OVERTURNING_-ph_left)/(HIF_BEE_OVERTURNING_/4.99)))),60,27,22);
HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);break;
case HIF_BEE_DEAD:
ASSIGNRECT(r1,x2,y2,2*HIF_BEE_HALFXSIZE+1,2*HIF_BEE_HALFYSIZE+1);ASSIGNRECT(r2,0,38,27,22);
HIF_BlitStdSurface(HIF_BEE_IMAGE,&r2,&r1);break;
};
};
}
void CHIF_Bee::proceed(void)
{
float f1,f2;
int i;
if (firetime!=0)firetime--;
if (  (MAX(x-HIF_BEE_HALFXSIZE,hif_player_info.x+hif_sizes[hif_player_info.size][0])<
        MIN(x+HIF_BEE_HALFXSIZE,hif_player_info.x+hif_sizes[hif_player_info.size][2]))&&
       (MAX(y-HIF_BEE_HALFYSIZE,hif_player_info.y+hif_sizes[hif_player_info.size][1])<
        MIN(y+HIF_BEE_HALFYSIZE,hif_player_info.y+hif_sizes[hif_player_info.size][3]))&&(hif_player_info.size!=3)&&(enabled==1)){
    if ((beer==0)||((SDL_GetModState()&KMOD_LSHIFT)!=0)){enabled=0;hif_player_info.t_drank=4*HIF_DRANK_QUATER-1;};
    if ((beer>0)&&(hif_player_info.t_drank<4*HIF_DRANK_QUATER)){hif_player_info.t_drank+=2;};};
if (enabled==1){switch(state){
  case HIF_BEE_PREROTATING:case HIF_BEE_BREATHING:case HIF_BEE_FLYING:
  f1=(x+1.5*sin(direction));f2=(y+1.5*cos(direction))+2*((hif_ticks/2)%4)-3;is_right=((f1>x)?(1):(0));
  if (hif_proceed_bee_cango(f1,f2)==0){x=f1;y=f2;}else
   if (state==HIF_BEE_PREROTATING)
        {direction=(rand()%360)/180.0*PI;state=HIF_BEE_FLYING;}else
    {if (rand()%5==0){state=HIF_BEE_FALLING;SND_PlayWave(_SND_bee_st_falling,0);}else
        {state=HIF_BEE_PREROTATING;ph_left=HIF_BEE_PREROTATING_;direction+=PI;SND_PlayWave(_SND_bee_thinking,0);};
    };
  direction+=((hif_ticks/4)%4*rand()%360-80)*PI/180.0/90.0;
  if (beer!=0){beer--;}else{state=HIF_BEE_DYING;};
  if (state==HIF_BEE_BREATHING){
  if (ph_left>0){ph_left--;}else{state=HIF_BEE_FLYING;};
  if (SQR(hif_level_info.enemies[enemy]->y-y)+SQR(hif_level_info.enemies[enemy]->x-x)>55){
  direction=acos((hif_level_info.enemies[enemy]->y-y)/sqrt(SQR(hif_level_info.enemies[enemy]->y-y)+SQR(hif_level_info.enemies[enemy]->x-x)));
  if (hif_level_info.enemies[enemy]->x<x){direction*=(-1.0);};
  };
  if ((hif_level_info.enemies[enemy]->health>0)&&(firetime==0)&&(hif_level_info.numfireballs<HIF_NUM_FIREBALLS)){
  hif_level_info.fireballs[hif_level_info.numfireballs].init(x+25*(2*is_right-1),y,direction);hif_level_info.numfireballs++;
  hif_level_info.bee.firetime=HIF_BEE_FIRETIME;};
  };break;
  case HIF_BEE_FALLING:case HIF_BEE_DYING:
  if (hif_proceed_bee_cango(x,y+1)==0){y++;};
  if (hif_proceed_bee_cango(x,y+1)==0){y++;}else
  {if(state==HIF_BEE_FALLING){state=HIF_BEE_OVERTURNING;ph_left=HIF_BEE_OVERTURNING_;} else {state=HIF_BEE_DEAD;ph_left=1;};};break;
  case HIF_BEE_OVERTURNING:
    if (beer!=0){beer--;}else{state=HIF_BEE_DYING;};if (ph_left>0){ph_left--;}else{state=HIF_BEE_RISING;ph_left=40;};break;
  case HIF_BEE_RISING:
    if (beer!=0){beer--;}else{state=HIF_BEE_DYING;};
    if (ph_left>0){ph_left--;if (hif_proceed_bee_cango(x,y-1)==0){y--;};}else{state=HIF_BEE_FLYING;};break;
  case HIF_BEE_DEAD:if (ph_left!=0){ph_left=0;hif_add_text(25,-20,LOCALE_HIF_BEEDIED_);};
  if (hif_proceed_bee_cango(x,y+1)==0){y++;};
  break;
  case HIF_BEE_DRINKING:if (ph_left!=0){ph_left--;}else{state=HIF_BEE_FLYING;};
  };
if (((SDL_GetModState()&KMOD_RSHIFT)!=0)&&(SQR(x-hif_player_info.x)+SQR(y-hif_player_info.y)>=16)){
  f1=asin((x-hif_player_info.x)/(sqrt(SQR(x-hif_player_info.x)+SQR(y-hif_player_info.y))));
  if (y<hif_player_info.y)f1=PI-f1;direction=direction*0.9+0.1*f1;};
if ((SDL_GetModState()&KMOD_LSHIFT)!=0){
if (hif_proceed_bee_cango(x+SGN(hif_player_info.x-x),y)==0){x+=SGN(hif_player_info.x-x);};
if (hif_proceed_bee_cango(x+SGN(hif_player_info.x-x),y)==0){x+=SGN(hif_player_info.x-x);};
if (hif_proceed_bee_cango(x,y+SGN(hif_player_info.y-y))==0){y+=SGN(hif_player_info.y-y);};
if (hif_proceed_bee_cango(x,y+SGN(hif_player_info.y-y))==0){y+=SGN(hif_player_info.y-y);};
};
if ((1+beer*40/HIF_BEE_MAXBEER!=beer_line)&&(beer!=0)&&(hif_level_info.numlines<HIF_NUM_LINES)) {
beer_line=1+beer*40/HIF_BEE_MAXBEER;
hif_level_info.lines[hif_level_info.numlines].init((int)hif_level_info.bee.x+25,(int)hif_level_info.bee.y-25,255,255,0,hif_level_info.bee.beer_line);
hif_level_info.numlines++;};
if (state==HIF_BEE_FLYING)for(i=0;i<hif_level_info.numenemies;i++){
if ((abs((int)x-hif_level_info.enemies[i]->x)<100)&&(abs((int)y-hif_level_info.enemies[i]->y)<100)&&(hif_level_info.enemies[i]->health!=0))
  {enemy=i;ph_left=HIF_BEE_BREATHING_;state=HIF_BEE_BREATHING;SND_PlayWave(_SND_bee_breathing,220);break;};
};
};
}
void CHIF_Bee::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(enabled);SAVEFIELD(beer);SAVEFIELD(state);SAVEFIELD(enemy);SAVEFIELD(firetime);SAVEFIELD(direction);
SAVEFIELD(ph_left);SAVEFIELD(is_right);SAVEFIELD(beer_line);
}
void CHIF_Bee::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(enabled);GETFIELD(beer);GETFIELD(state);GETFIELD(enemy);GETFIELD(firetime);GETFIELD(direction);
GETFIELD(ph_left);GETFIELD(is_right);GETFIELD(beer_line);
}
void CHIF_Line::init(int x_,int y_,Uint16 rc_,Uint16 gc_,Uint16 bc_,Uint16 len_)
{
x=x_;y=y_;rc=rc_;gc=gc_;bc=bc_;len=len_;phase=HIF_LINES_NUMPHASES;
}
void CHIF_Line::refresh(int x0,int y0)
{
SDL_Rect r1={x-x0,y-y0,len,1};
float k=(float)phase/HIF_LINES_NUMPHASES;
HIF_FillRect(screen,&r1,SDL_MapRGB(screen->format,(int)(rc*k),(int)(gc*k),(int)(bc*k)));
}
int CHIF_Line::proceed(void)
{
if(phase!=0){phase--;x++;y--;return 0;}else{return -1;};
}
void CHIF_Line::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(phase);SAVEFIELD(rc);SAVEFIELD(gc);SAVEFIELD(bc);SAVEFIELD(len);
}
void CHIF_Line::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(phase);GETFIELD(rc);GETFIELD(gc);GETFIELD(bc);GETFIELD(len);
}
void CHIF_Block::init(int x1_,int y1_,int x2_,int y2_,char type_)
{
x1=x1_;y1=y1_;x2=x2_;y2=y2_;type=type_;phase=0;
}
void CHIF_Block::refresh(int x0,int y0)
{
SDL_Rect r2={x1-x0,y1-y0,x2-x1,y2-y1},r1;
r1=r2;
switch (type){
case HIF_BLOCK_WHITEWALL:
HIF_FillRect(screen,&r1,C_GRAY(screen,150));ASSIGNRECT(r1,r2.x,r2.y,r2.w,1);
HIF_FillRect(screen,&r1,C_GRAY(screen,190));ASSIGNRECT(r1,r2.x,r2.y,1,r2.h);
HIF_FillRect(screen,&r1,C_GRAY(screen,190));ASSIGNRECT(r1,r2.x+r2.w,r2.y,1,r2.h);
HIF_FillRect(screen,&r1,C_GRAY(screen,110));ASSIGNRECT(r1,r2.x,r2.y+r2.h,r2.w+1,1);
HIF_FillRect(screen,&r1,C_GRAY(screen,110));break;
case HIF_BLOCK_METALWALLH:
HIF_FillRect(screen,&r1,C_GRAY(screen,90));if (phase<=x2-x1-2){
  ASSIGNRECT(r1,r2.x+r2.w-2-phase,r2.y,3,r2.h);HIF_FillRect(screen,&r1,C_GRAY(screen,93));};break;
case HIF_BLOCK_METALWALLV:
HIF_FillRect(screen,&r1,C_GRAY(screen,90));if (phase<=y2-y1-2){
  ASSIGNRECT(r1,r2.x,r2.y+r2.h-2-phase,r2.w,3);HIF_FillRect(screen,&r1,C_GRAY(screen,93));};break;
};
}
void CHIF_Block::proceed(void)
{
phase+=1+rand()%(1+(hif_ticks%5));
switch(type){
case HIF_BLOCK_WHITEWALL:break;
case HIF_BLOCK_METALWALLH:phase%=2*(x2-x1+1);break;
case HIF_BLOCK_METALWALLV:phase%=2*(y2-y1+1);break;
};
}
void CHIF_Block::save(BZFILE *f)
{
SAVEFIELD(x1);SAVEFIELD(y1);SAVEFIELD(x2);SAVEFIELD(y2);SAVEFIELD(type);SAVEFIELD(phase);
}
void CHIF_Block::load(BZFILE *f)
{
GETFIELD(x1);GETFIELD(y1);GETFIELD(x2);GETFIELD(y2);GETFIELD(type);GETFIELD(phase);
}
void CHIF_Air::init(int x_,int y_)
{
x=x_;y=y_;
}
void CHIF_Air::refresh(int x0,int y0)
{
SDL_Rect r1={x-1-x0,y-2-y0,3,1},r2={x-1-x0,y+2-y0,3,1},r3={x-2-x0,y-1-y0,1,3},r4={x+2-x0,y-1-y0,1,3};
HIF_FillRect(screen,&r1,C_GRAY(screen,250));
HIF_FillRect(screen,&r2,C_GRAY(screen,200));
HIF_FillRect(screen,&r3,C_GRAY(screen,230));
HIF_FillRect(screen,&r4,C_GRAY(screen,230));
}
int CHIF_Air::proceed(void)
{
int i2,t=-1;
y--;switch (hif_ticks%4){case 0:x-=2;break;case 2:x+=2;break;};
for (i2=0;i2<hif_level_info.numrivers;i2++)if(
  (hif_level_info.rivers[i2].x<=x)&&
  (hif_level_info.rivers[i2].y<=y)&&
  (hif_level_info.rivers[i2].x+hif_level_info.rivers[i2].xs>=x)&&
  (hif_level_info.rivers[i2].y+hif_level_info.rivers[i2].ys>=y))
    {t=0;break;}
return t;
}
void CHIF_Air::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);
}
void CHIF_Air::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);
}
Sint16 *CHIF_SmallEnemy::get_info(Sint16 *t)
{
type=*t++;x=*t++;y=*t++;thing=*t++;no_things=*t++;n_traps=0;dead=0;health=HIF_ENEMY_HEALTH(type);
health_line=40;n_mines=0;t_asleep=0;phase=0;sleeptime=0;state=0;is_hurt=0;return t;
}
void CHIF_SmallEnemy::refresh(int x0,int y0)
{
SDL_Rect r1={x-x0-2,y-y0-2,5,5},r2={5*thing,0,5,5},r3={90,0,5,5};
if (SQR(hif_player_info.x-x)+SQR(hif_player_info.y-y)<SQR(HIF_INFO_DIST))HIF_BlitStdSurface(_IMG_hif_things,(thing==-1)?(&r3):(&r2),&r1);
}
void CHIF_SmallEnemy::all_proceed(void)
{
int i2;
char gets_thing=0;
if(dead==0){proceed();
if ((MAX(hif_player_info.x+hif_sizes[hif_player_info.size][0],x+HIF_ENEMY_SIZE(type,0))<
        MIN(hif_player_info.x+hif_sizes[hif_player_info.size][2],x+HIF_ENEMY_SIZE(type,2)))&&
      (MAX(hif_player_info.y+hif_sizes[hif_player_info.size][1],y+HIF_ENEMY_SIZE(type,1))<
        MIN(hif_player_info.y+hif_sizes[hif_player_info.size][3],y+HIF_ENEMY_SIZE(type,3)))){
    if ((hif_player_info.size==3)&&(health!=0))health--;
if ((HIF_ENEMY_DAMAGE(type)!=0)&&(hif_ticks%3==0)&&(t_asleep==0))
        {hif_player_info.health-=HIF_ENEMY_DAMAGE(type);hif_to_update_panel=1;hif_proceed_trytogo(rand()%5-2,rand()%5-2);};};
if (health_line!=(health*40/HIF_ENEMY_HEALTH(type)))if (hif_level_info.numlines<HIF_NUM_LINES){
  health_line=(health*40/HIF_ENEMY_HEALTH(type));hif_level_info.lines[hif_level_info.numlines++].init(x+25,y-25,140,140,140,health_line);};
for (i2=0;i2<hif_level_info.numthings;i2++)
       if ((hif_level_info.things[i2].is_hurting==1)||(hif_level_info.things[i2].type==HIF_THING_FIRSTSHELL+5)||
                                        (hif_level_info.things[i2].type==HIF_THING_TRAPMINE))
 if (((hif_level_info.things[i2].type>=HIF_THING_FIRSTSHELL)&&(hif_level_info.things[i2].type<=HIF_THING_FIRSTSHELL+5))||
        (hif_level_info.things[i2].type==HIF_THING_DOT)||(hif_level_info.things[i2].type==HIF_THING_TRAPMINE))
  if ((MAX(hif_level_info.things[i2].x-2,x+HIF_ENEMY_SIZE(type,0))<MIN(hif_level_info.things[i2].x+2,x+HIF_ENEMY_SIZE(type,2)))&&
      (MAX(hif_level_info.things[i2].y-2,y+HIF_ENEMY_SIZE(type,1))<MIN(hif_level_info.things[i2].y+2,y+HIF_ENEMY_SIZE(type,3)))){
switch (hif_level_info.things[i2].type){
case HIF_THING_TRAPMINE:health-=HIF_TRAP_DAMAGE*hif_level_info.things[i2].no;gets_thing=1;if (health<0)health=0;
  n_traps+=hif_level_info.things[i2].no;n_mines+=hif_level_info.things[i2].no;is_hurt=1;break;
case HIF_THING_DOT:is_hurt=1;gets_thing=1;health_line=41;break;
case HIF_THING_FIRSTSHELL:case HIF_THING_FIRSTSHELL+1:case HIF_THING_FIRSTSHELL+2:
  health-=hif_weapon_damages[hif_level_info.things[i2].type-HIF_THING_FIRSTSHELL]*hif_level_info.things[i2].no;
  if (health<0)health=0;gets_thing=1;is_hurt=1;break;
case HIF_THING_FIRSTSHELL+3:t_asleep+=HIF_SLEEP_SMALL;sleeptime+=HIF_SLEEP_SMALL;gets_thing=1;break;
case HIF_THING_FIRSTSHELL+4:t_asleep+=HIF_SLEEP_BIG;sleeptime+=HIF_SLEEP_BIG;gets_thing=1;break;
case HIF_THING_FIRSTSHELL+5:health-=HIF_TRAP_DAMAGE*hif_level_info.things[i2].no;gets_thing=1;if (health<0)health=0;
n_traps+=hif_level_info.things[i2].no;is_hurt=1;break;
};if (gets_thing==1)hif_unregister_thing(i2--);if (health<=0)break;
   };
if (health<=0){dead=1;if ((thing!=-1)&&(hif_level_info.numthings!=HIF_NUM_THINGS))hif_register_thing(x,y,0,0,no_things,thing,0,0);
if (hif_numevents<HIF_NUM_EVENTS){
  hif_events[hif_numevents].type=HIF_EVENT_ENEMY_DYING;
  hif_events[hif_numevents].phase=HIF_ENEMY_DEADPHASES(type);
  hif_events[hif_numevents].image1=type;
  hif_events[hif_numevents].x=x+HIF_ENEMY_SIZE(type,0);
  hif_events[hif_numevents].y=y+HIF_ENEMY_SIZE(type,1);
  hif_numevents++;};
if ((hif_level_info.numthings<HIF_NUM_THINGS)&&(n_traps!=0)){hif_register_thing(x,y,0,-30,n_traps,HIF_THING_TRAPOFF,0,0);
  if ((hif_level_info.numthings<HIF_NUM_THINGS)&&(n_mines!=0)){hif_register_thing(x,y,0,-30,n_mines,HIF_THING_FIRSTSHELL+6,0,0);};};};};
}
void CHIF_SmallEnemy::save(BZFILE *f)
{
SAVEFIELD(type);SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(phase);SAVEFIELD(n_traps);SAVEFIELD(n_mines);SAVEFIELD(health);SAVEFIELD(t_asleep);
SAVEFIELD(sleeptime);SAVEFIELD(state);SAVEFIELD(health_line);SAVEFIELD(dead);SAVEFIELD(thing);SAVEFIELD(no_things);
}
void CHIF_SmallEnemy::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(phase);GETFIELD(n_traps);GETFIELD(n_mines);GETFIELD(health);GETFIELD(t_asleep);
GETFIELD(sleeptime);GETFIELD(state);GETFIELD(health_line);GETFIELD(dead);GETFIELD(thing);GETFIELD(no_things);
}
Sint16 *CHIF_Enemy_Ghost::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);r_small=*t++;r_big=*t++;t_small=*t++;t_big=*t++;x0=x;y0=y;return t;
}
void CHIF_Enemy_Ghost::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={40*(hif_ticks%8),360,40,40};
HIF_BlitStdSurface(_IMG_hif_hed_images_ani,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Ghost::proceed(void)
{
if (t_asleep>0){t_asleep--;}else{
x=(int)(x0+sin(2.0*PI/t_small*((hif_ticks-sleeptime)%t_small))*((r_small+r_big)/2.0+
      (r_big-r_small)/2.0*sin(2.0*PI/t_big*((hif_ticks-sleeptime)%t_big))));
y=(int)(y0+cos(2.0*PI/t_small*((hif_ticks-sleeptime)%t_small))*((r_small+r_big)/2.0+
      (r_big-r_small)/2.0*cos(2.0*PI/t_big*((hif_ticks-sleeptime)%t_big))));};
}
void CHIF_Enemy_Ghost::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(r_small);SAVEFIELD(r_big);SAVEFIELD(t_small);SAVEFIELD(t_big);SAVEFIELD(x0);SAVEFIELD(y0);
}
void CHIF_Enemy_Ghost::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(r_small);GETFIELD(r_big);GETFIELD(t_small);GETFIELD(t_big);GETFIELD(x0);GETFIELD(y0);
}
Sint16 *CHIF_Enemy_Snail::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);x1=x;x2=*t++;return t;
}
void CHIF_Enemy_Snail::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={40*(hif_ticks%4),40*((phase>x2-x1)?(14):(13)),40,40};
HIF_BlitStdSurface(_IMG_hif_hed_images_ani,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Snail::proceed(void)
{
if (t_asleep>0){t_asleep--;}else{phase+=2+(hif_ticks%2);phase%=2*(x2-x1);x=x2-abs(x2-x1-phase);};
}
void CHIF_Enemy_Snail::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(x1);SAVEFIELD(x2);
}
void CHIF_Enemy_Snail::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(x1);GETFIELD(x2);
}
Sint16 *CHIF_Enemy_Car::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);x1=x;x2=*t++;return t;
}
void CHIF_Enemy_Car::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={40*(hif_ticks%8),15*40,40,40};
HIF_BlitStdSurface(_IMG_hif_hed_images_ani,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Car::proceed(void)
{
if (t_asleep>0){t_asleep--;}else{phase+=4+(hif_ticks%2);phase%=2*(x2-x1);x=x2-abs(x2-x1-phase);};
}
void CHIF_Enemy_Car::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(x1);SAVEFIELD(x2);
}
void CHIF_Enemy_Car::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(x1);GETFIELD(x2);
}
Sint16 *CHIF_Enemy_Gun::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);shoottime=0;num_shells=*t++;maxtime=*t++;v=*t++;x1=*t++;y1=*t++;x2=*t++;y2=*t++;return t;
}
void CHIF_Enemy_Gun::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={120+40*(type-HIF_ENEMY_GUN),80,40,40};
  HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Gun::proceed(void)
{
if (t_asleep!=0){t_asleep--;}else{
if (shoottime!=0){shoottime--;}else{
if ((hif_player_info.x>=x1)&&(hif_player_info.x<=x2)&&(hif_player_info.y>=y1)&&(hif_player_info.y<=y2)&&
  (hif_level_info.numthings<HIF_NUM_THINGS)&&(num_shells!=0)&&
  (hif_proceed_can_thing(x+22*SGN(hif_player_info.x-x),y+22*SGN(hif_player_info.y-y))==0)){
int x_sh=x+22*SGN(hif_player_info.x-x),y_sh=y+22*SGN(hif_player_info.y-y);float d=sqrt(SQR(hif_player_info.x-x)+SQR(hif_player_info.y-y));
 if (hif_proceed_can_thing(x_sh,y_sh)==0){
hif_register_thing(x_sh,y_sh,(float)v*(float)(hif_player_info.x-x)/d,(float)v*(float)(hif_player_info.y-y)/d,1,
                HIF_THING_FIRSTSHELL+type-HIF_ENEMY_GUN,1,0);shoottime=maxtime;num_shells--;};};};};
}
void CHIF_Enemy_Gun::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);
SAVEFIELD(num_shells);SAVEFIELD(shoottime);SAVEFIELD(maxtime);SAVEFIELD(v);SAVEFIELD(x1);SAVEFIELD(y1);SAVEFIELD(x2);SAVEFIELD(y2);
}
void CHIF_Enemy_Gun::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);
GETFIELD(num_shells);GETFIELD(shoottime);GETFIELD(maxtime);GETFIELD(v);GETFIELD(x1);GETFIELD(y1);GETFIELD(x2);GETFIELD(y2);
}
void CHIF_Enemy_Pank::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={(is_right==1)?(40):(80),120,40,40};
HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Pank::proceed(void)
{
if (t_asleep!=0){t_asleep--;}else{
is_right=((hif_player_info.x>x)?(1):(0));
if (abs(x-hif_player_info.x)>1)if (hif_proceed_enemy_cango(x+4*is_right-2,y,HIF_ENEMY_PANK)==0)x+=4*is_right-2;
if (hif_proceed_enemy_cango(x,y+1,HIF_ENEMY_PANK)==0){y++;}
};
}
void CHIF_Enemy_Pank::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(is_right);
}
void CHIF_Enemy_Pank::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(is_right);
}
void CHIF_Enemy_Flower::create_flower(int x_,int y_)
{
type=HIF_ENEMY_FLOWER;x=x_;y=y_;thing=-1;n_traps=0;dead=0;health=HIF_ENEMY_HEALTH(HIF_ENEMY_FLOWER);
health_line=40;n_mines=0;t_asleep=0;phase=0;sleeptime=0;state=0;is_hurt=0;
}
Sint16 *CHIF_Enemy_Flower::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);return t;
}
void CHIF_Enemy_Flower::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={160,40,40,40};
HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r2,&r1);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Flower::proceed(void)
{
if ((is_hurt==0)&&(t_asleep!=0)){t_asleep--;}else{
if ((SQR(x-hif_player_info.x)+SQR(y-hif_player_info.y)<=SQR(HIF_FLOWER_DIST)&&(hif_level_info.numthings!=HIF_NUM_THINGS))
      ||(is_hurt==1)){hif_proceed_explode_no(hif_register_thing(x,y,0,0,1,HIF_THING_FIRSTSHELL+6,0,0),1);health=0;};};
}
Sint16 *CHIF_Enemy_Droid::get_info(Sint16 *t)
{
t=CHIF_SmallEnemy::get_info(t);is_falling=1;flowerleft=*t++;return t;
}
void CHIF_Enemy_Droid::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={0,120,40,40},r3={x-x0+23,y-y0-23,flowerleft,1},r4={r3.x,r3.y+1,r3.w,1};
HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r2,&r1);
  HIF_FillRect(screen,&r3,SDL_MapRGB(screen->format,100,100,100));
  HIF_FillRect(screen,&r4,SDL_MapRGB(screen->format,155,155,155));
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_Droid::proceed(void)
{
int i2;
if (is_hurt==1){is_hurt=0;if (hif_proceed_enemy_cango(x,y+1,HIF_ENEMY_DROID)==0)is_falling=1;};
if (t_asleep!=0){t_asleep--;}else{
if (is_falling==1){
for (i2=0;i2<3+rand()%2;i2++){
if (hif_proceed_enemy_cango(x,y+1,HIF_ENEMY_DROID)==0){y++;}else
 {is_falling=0;_z=3;_v=2*(rand()%2);
    if ((flowerleft!=0)&&(hif_level_info.numenemies!=HIF_NUM_ENEMIES)){
        CHIF_Enemy_Flower *f=new CHIF_Enemy_Flower();
        f->create_flower(x,y);flowerleft--;hif_level_info.enemies[hif_level_info.numenemies++]=f;
};break;};};
} else {
if (hif_proceed_enemy_cango(x+hif_directions[_z][0],y+hif_directions[_z][1],HIF_ENEMY_DROID)==0){i2=_z;_z=_v^2;_v=i2;} else {
  if (hif_proceed_enemy_cango(x+hif_directions[_v][0],y+hif_directions[_v][1],HIF_ENEMY_DROID)!=0){i2=_z;_z=_v;_v=i2^2;};};
if (hif_proceed_enemy_cango(x+hif_directions[_v][0],y+hif_directions[_v][1],HIF_ENEMY_DROID)==0){
      x+=hif_directions[_v][0];y+=hif_directions[_v][1];};};};
}
void CHIF_Enemy_Droid::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(_v);SAVEFIELD(_z);SAVEFIELD(is_falling);SAVEFIELD(flowerleft);
}
void CHIF_Enemy_Droid::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(_v);GETFIELD(_z);GETFIELD(is_falling);GETFIELD(flowerleft);
}
Sint16 *CHIF_Enemy_BigBee::get_info(Sint16 *t)
{
is_up=0;is_right=0;return (CHIF_SmallEnemy::get_info(t));
}
void CHIF_Enemy_BigBee::refresh(int x0,int y0)
{
SDL_Rect r1={x-19-x0,y-19-y0,40,40},r2={(is_right==0)?(80):(40),80,40,40},r3={(is_right==0)?(0):(50),5*(2+(hif_ticks/2)%4),20,5},
    r4={x-x0+((is_right==0)?(21):(-39)),y-y0-7,20,5};
HIF_BlitStdSurface(_IMG_hif_hed_images_2,&r2,&r1);
HIF_BlitStdSurface(_IMG_hif_things,&r3,&r4);
CHIF_SmallEnemy::refresh(x0,y0);
}
void CHIF_Enemy_BigBee::proceed(void)
{
int i2;
i2=rand()%4;if (is_right==0)i2=-i2;if (hif_proceed_enemy_cango(x+i2,y,HIF_ENEMY_BIGBEE)){is_right^=1;}else{x+=i2;};
i2=rand()%4;if (is_up==1)i2=-i2;if (hif_proceed_enemy_cango(x,y+i2,HIF_ENEMY_BIGBEE)){is_up^=1;}else{y+=i2;};
}
void CHIF_Enemy_BigBee::save(BZFILE *f)
{
CHIF_SmallEnemy::save(f);SAVEFIELD(is_right);SAVEFIELD(is_up);
}
void CHIF_Enemy_BigBee::load(BZFILE *f)
{
CHIF_SmallEnemy::load(f);GETFIELD(is_right);GETFIELD(is_up);
}
#define HIF_MAD_ASKING 0
#define HIF_MAD_QUESTION 1
#define HIF_MAD_THINKING 2
#define HIF_MAD_OUT 3
Sint16 *CHIF_Enemy_Mad::get_info(Sint16 *t)
{
}
void CHIF_Enemy_Mad::refresh(int x0,int y0)
{
}
void CHIF_Enemy_Mad::proceed(void)
{

}
void CHIF_Enemy_Mad::save(BZFILE *f)
{
}
void CHIF_Enemy_Mad::load(BZFILE *f)
{
}
void CHIF_ScTh::init(int x_,int y_,char image_,int x1_,int y1_,int w_,int h_)
{
x=x_;y=y_;image=image_;x1=x1_;y1=y1_;w=w_;h=h_;is_out=0;cx=hif_player_info.x;cy=hif_player_info.y;
}
void CHIF_ScTh::refresh(int x0,int y0)
{
SDL_Rect r1={(int)x-w/2-x0,(int)y-h/2-y0,w,h},r2={x1,y1,w,h};
HIF_BlitStdSurface(image,&r2,&r1);
if ((x<x0)||(y<y0)||(x>=x0+640)||(y>=y0+480))is_out=1;
}
int CHIF_ScTh::proceed(void)
{
#define CHIF_SCTH_ANGLE 0.25
#define CHIF_SCTH_K 1.03
float old_x=x-cx,old_y=y-cy;
x=cx+((old_x*cos(CHIF_SCTH_ANGLE)-old_y*sin(CHIF_SCTH_ANGLE))*CHIF_SCTH_K)+((float)rand())/RAND_MAX-0.5;
y=cy+((old_x*sin(CHIF_SCTH_ANGLE)+old_y*cos(CHIF_SCTH_ANGLE))*CHIF_SCTH_K)+((float)rand())/RAND_MAX-0.5;
return (-is_out);
}
void CHIF_ScTh::save(BZFILE *f)
{
SAVEFIELD(x);SAVEFIELD(y);SAVEFIELD(x1);SAVEFIELD(y1);SAVEFIELD(w);SAVEFIELD(h);SAVEFIELD(image);
}
void CHIF_ScTh::load(BZFILE *f)
{
GETFIELD(x);GETFIELD(y);GETFIELD(x1);GETFIELD(y1);GETFIELD(w);GETFIELD(h);GETFIELD(image);
}
