#include <bzlib.h>
#include <SDL/SDL_types.h>
#include "hif_main.h"
#include "images.h"
#include <stdlib.h>
#include <string.h>
#include "hif_levels.h"
#include "sg.h"
#include <time.h>
#include "misc.h"
#include "log.h"
#define LSAVEFIELD(q) BZ2_bzwrite(f,&(hif_level_info.q),sizeof(hif_level_info.q))
#define LSAVEARRAY(q) BZ2_bzwrite(f,hif_level_info.q,sizeof(hif_level_info.q))
#define LGETFIELD(q) BZ2_bzread(f,&(hif_level_info.q),sizeof(hif_level_info.q))
#define LGETARRAY(q) BZ2_bzread(f,hif_level_info.q,sizeof(hif_level_info.q))
CHIF_Enemy *HIF_CreateEnemy(int type)
{
switch (type){
case HIF_ENEMY_GHOST:return new CHIF_Enemy_Ghost;break;
case HIF_ENEMY_CAR:return new CHIF_Enemy_Car;break;
case HIF_ENEMY_SNAIL:return new CHIF_Enemy_Snail;break;
case HIF_ENEMY_GUN:case HIF_ENEMY_GUN+1:case HIF_ENEMY_GUN+2:return new CHIF_Enemy_Gun;break;
case HIF_ENEMY_PANK:return new CHIF_Enemy_Pank;break;
case HIF_ENEMY_DROID:return new CHIF_Enemy_Droid;break;
case HIF_ENEMY_FLOWER:return new CHIF_Enemy_Flower;break;
case HIF_ENEMY_BIGBEE:return new CHIF_Enemy_BigBee;break;
case HIF_ENEMY_MAD:return new CHIF_Enemy_Mad;break;
default:fprintf(LOG,"Warning (hif_file.cpp): unknown enemy type %i\n",type);return NULL;break;
};
}
void hif_loadlevel(int no)
{
Sint16 *t;
int i,i1,i2;
#include "hif_levels.inc"
fprintf(LOG,"HIF:Loading level %i -",no);
hif_handler=(HIF_BUTTON_HANDLER*)hif_levels[no][1];
t=(Sint16*)hif_levels[no][0];
memset(&hif_level_info,0,sizeof(hif_level_info));
hif_level_info.xsize=*t++;hif_level_info.ysize=*t++;
  hif_level_info.thing_map=(int *)malloc(sizeof(int)*(hif_level_info.xsize*hif_level_info.ysize+1));
  hif_level_info.thing_map_rest=(int *)malloc(sizeof(int)*(hif_level_info.xsize*hif_level_info.ysize+1));
hif_level_info.numair=0;
hif_player_info.x=*t++;hif_player_info.y=*t++;
hif_player_info.vy=0;
memcpy(&(hif_level_info.bg[0]),t,sizeof(Uint16)*hif_level_info.xsize*hif_level_info.ysize);t+=hif_level_info.xsize*hif_level_info.ysize;
memcpy(&(hif_level_info.walls[0]),t,sizeof(Uint16)*hif_level_info.xsize*hif_level_info.ysize);t+=hif_level_info.xsize*hif_level_info.ysize;
memcpy(&(hif_level_info.fg[0]),t,sizeof(Uint16)*hif_level_info.xsize*hif_level_info.ysize);t+=hif_level_info.xsize*hif_level_info.ysize;
memcpy(&(hif_level_info.keepers[0]),t,sizeof(Uint16)*hif_level_info.xsize*hif_level_info.ysize);t+=hif_level_info.xsize*hif_level_info.ysize;
hif_map=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,2*hif_level_info.xsize,2*hif_level_info.ysize,32,SURFACE_COLOURS);
SDL_FillRect(hif_map,NULL,C_GRAY(hif_map,120));memset(hif_level_info.map,-1,HIF_LEVEL_MAPSIZE);
hif_level_info.numthings=hif_level_info.numthings=0;i2=*t++;for (i=0;i<i2;i++)t=hif_get_thing(t);
hif_level_info.numdrops=*t++;for (i=0;i<hif_level_info.numdrops;i++)t=hif_level_info.drops[i].get_info(t);
hif_level_info.numvents=*t++;
for (i=0;i<hif_level_info.numvents;i++){
    hif_level_info.vents[i].x=*t++;hif_level_info.vents[i].y=*t++;i1=*t++;i2=*t++;
    hif_level_info.vents[i].xs=i1;hif_level_info.vents[i].ys=i2;
    hif_fastwalks[0][i]=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,i1,i2,32,SURFACE_COLOURS);
    SDL_FillRect(hif_fastwalks[0][i],NULL,C_BLACK(hif_fastwalks[0][i]));
    hif_level_info.vents[i].v=*t++;hif_level_info.vents[i].phase=0;
    for (i1=0;i1<=((hif_fastwalks[0][i]->w)*(hif_fastwalks[0][i]->h)/100);i1++){
      SDL_Rect r1={rand()%hif_fastwalks[0][i]->w,rand()%hif_fastwalks[0][i]->h,1,1};i2=rand()%140;
      SDL_FillRect(hif_fastwalks[0][i],&r1,SDL_MapRGB(hif_fastwalks[0][i]->format,i2,i2,i2));
      r1.y++;
      SDL_FillRect(hif_fastwalks[0][i],&r1,SDL_MapRGB(hif_fastwalks[0][i]->format,i2/10,i2/10,i2/10));};
};
hif_level_info.numrivers=*t++;
for (i=0;i<hif_level_info.numrivers;i++){
    hif_level_info.rivers[i].x=*t++;hif_level_info.rivers[i].y=*t++;i1=*t++;i2=*t++;
    hif_level_info.rivers[i].xs=i1;hif_level_info.rivers[i].ys=i2;
    hif_fastwalks[1][i]=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,i1,i2,32,SURFACE_COLOURS);
    hif_level_info.rivers[i].v=*t++;hif_level_info.rivers[i].phase=0;
//fill river
for (i1=0;i1<hif_fastwalks[1][i]->h;i1++){
SDL_Rect r1={0,i1,hif_fastwalks[1][i]->w,1};
SDL_FillRect(hif_fastwalks[1][i],&r1,SDL_MapRGB(hif_fastwalks[1][i]->format,50,150,250));
};
for (i1=0;i1<=hif_fastwalks[1][i]->w*hif_fastwalks[1][i]->h/200;i1++){
SDL_Rect r1={rand()%hif_fastwalks[1][i]->w,rand()%hif_fastwalks[1][i]->h,rand()%8+2,1};
SDL_FillRect(hif_fastwalks[1][i],&r1,SDL_MapRGB(hif_fastwalks[1][i]->format,250,250,250));
};
};
hif_level_info.numenemies=*t++;
for (i=0;i<hif_level_info.numenemies;i++){
hif_level_info.enemies[i]=HIF_CreateEnemy(*t);
t=hif_level_info.enemies[i]->get_info(t);
};
hif_level_info.numblocks=*t++;hif_level_info.numblocks_real=*t++;
for (i=0;i<hif_level_info.numblocks;i++){
hif_level_info.blocks[i].x1=*t++;hif_level_info.blocks[i].y1=*t++;hif_level_info.blocks[i].x2=*t++;hif_level_info.blocks[i].y2=*t++;
hif_level_info.blocks[i].phase=0;hif_level_info.blocks[i].type=*t++;
};
hif_handler(HIF_LEVHAND_INIT,0,NULL,0,0);
fprintf(LOG,"OK\n");
}
void hif_loadsg(char no)
{
BZFILE *f;
struct SAVE_REC r;
int i,x,y;
fprintf(LOG,"HIF: loading SG %i -",no);
SGname[SGOFFSET]='0'+no/10;SGname[SGOFFSET+1]='0'+no%10;
if ((f=BZ2_bzopen(SGname,"r"))==NULL){misc_fail("Error opering file for load.");fprintf(LOG,"fail1\n");return;};
BZ2_bzread(f,&r,sizeof(r));
BZ2_bzread(f,&hif_level,sizeof(int));hif_loadlevel(hif_level);hif_stillplaying=1;hif_victory=0;
BZ2_bzread(f,&hif_player_info,sizeof(hif_player_info));
//load level
LGETFIELD(xsize);
LGETFIELD(ysize);
LGETARRAY(bg);
LGETARRAY(fg);
LGETARRAY(walls);
LGETARRAY(keepers);
LGETARRAY(map);
LGETFIELD(numdrops);
for (i=0;i<hif_level_info.numdrops;i++)hif_level_info.drops[i].load(f);
LGETFIELD(numair);
for (i=0;i<hif_level_info.numair;i++)hif_level_info.air[i].load(f);
LGETFIELD(numthings);
for (i=0;i<hif_level_info.numthings;i++)hif_level_info.things[i].load(f);
LGETFIELD(numthings_rest);
for (i=0;i<hif_level_info.numthings_rest;i++)hif_level_info.things_rest[i].load(f);
LGETFIELD(numvents);
for (i=0;i<hif_level_info.numvents;i++)hif_level_info.vents[i].load(f);
LGETFIELD(numrivers);
for (i=0;i<hif_level_info.numrivers;i++)hif_level_info.rivers[i].load(f);
LGETFIELD(numenemies);
for (i=0;i<hif_level_info.numenemies;i++){
  char c;
  BZ2_bzread(f,&c,1);hif_level_info.enemies[i]=HIF_CreateEnemy(c);hif_level_info.enemies[i]->load(f);hif_level_info.enemies[i]->type=c;
};
LGETFIELD(numfireballs);
for (i=0;i<hif_level_info.numfireballs;i++)hif_level_info.fireballs[i].load(f);
LGETFIELD(numscth);
for (i=0;i<hif_level_info.numscth;i++)hif_level_info.scth[i].load(f);
LGETFIELD(numblocks);
LGETFIELD(numblocks_real);
for (i=0;i<hif_level_info.numblocks;i++)hif_level_info.blocks[i].load(f);
LGETFIELD(numlines);
for (i=0;i<hif_level_info.numlines;i++)hif_level_info.lines[i].load(f);
hif_level_info.bee.load(f);
hif_handler(HIF_LEVHAND_LOAD,0,f,0,0);
BZ2_bzread(f,&hif_numevents,sizeof(hif_numevents));
  if (BZ2_bzread(f,hif_events,sizeof(HIF_EVENT)*hif_numevents)<(int)sizeof(HIF_EVENT)*hif_numevents)
    {misc_fail("Error opering file for load.");fprintf(LOG,"fail2\n");return;};
BZ2_bzclose(f);
for (x=0;x<hif_level_info.xsize;x++)for (y=0;y<hif_level_info.ysize;y++)if(hif_level_info.map[y*hif_level_info.xsize+x]!=-1)
{
SDL_Rect r1={x*2,y*2,2,2};i=hif_level_info.map[y*hif_level_info.xsize+x];
SDL_FillRect(hif_map,&r1,SDL_MapRGB(hif_map->format,hif_mapC[i][0],hif_mapC[i][1],hif_mapC[i][2]));
};
fprintf(LOG,"OK\n");
}
void hif_savesg(char no)
{
BZFILE *f;
SAVE_REC r={time(0),0};
int i;
fprintf(LOG,"HIF: saving SG %i\n",no);
SGname[SGOFFSET]='0'+no/10;SGname[SGOFFSET+1]='0'+no%10;
if ((f=BZ2_bzopen(SGname,"w"))==NULL){misc_fail("Error opering file for save.");return;};
BZ2_bzwrite(f,&r,sizeof(r));
BZ2_bzwrite(f,&hif_level,sizeof(int));
BZ2_bzwrite(f,&hif_player_info,sizeof(hif_player_info));
//save level
LSAVEFIELD(xsize);
LSAVEFIELD(ysize);
LSAVEARRAY(bg);
LSAVEARRAY(fg);
LSAVEARRAY(walls);
LSAVEARRAY(keepers);
LSAVEARRAY(map);
LSAVEFIELD(numdrops);
for (i=0;i<hif_level_info.numdrops;i++)hif_level_info.drops[i].save(f);
LSAVEFIELD(numair);
for (i=0;i<hif_level_info.numair;i++)hif_level_info.air[i].save(f);
LSAVEFIELD(numthings);
for (i=0;i<hif_level_info.numthings;i++)hif_level_info.things[i].save(f);
LSAVEFIELD(numthings_rest);
for (i=0;i<hif_level_info.numthings_rest;i++)hif_level_info.things_rest[i].save(f);
LSAVEFIELD(numvents);
for (i=0;i<hif_level_info.numvents;i++)hif_level_info.vents[i].save(f);
LSAVEFIELD(numrivers);
for (i=0;i<hif_level_info.numrivers;i++)hif_level_info.rivers[i].save(f);
LSAVEFIELD(numenemies);
for (i=0;i<hif_level_info.numenemies;i++)hif_level_info.enemies[i]->save(f);
LSAVEFIELD(numfireballs);
for (i=0;i<hif_level_info.numfireballs;i++)hif_level_info.fireballs[i].save(f);
LSAVEFIELD(numscth);
for (i=0;i<hif_level_info.numscth;i++)hif_level_info.scth[i].save(f);
LSAVEFIELD(numblocks);
LSAVEFIELD(numblocks_real);
for (i=0;i<hif_level_info.numblocks;i++)hif_level_info.blocks[i].save(f);
LSAVEFIELD(numlines);
for (i=0;i<hif_level_info.numlines;i++)hif_level_info.lines[i].save(f);
hif_level_info.bee.save(f);
hif_handler(HIF_LEVHAND_SAVE,0,f,0,0);
BZ2_bzwrite(f,&hif_numevents,sizeof(hif_numevents));BZ2_bzwrite(f,hif_events,sizeof(HIF_EVENT)*hif_numevents);
//save events and close file
BZ2_bzclose(f);
}
