#include "hif_graphics.h"
#include "log.h"
#include "images.h"
#include "hif_main.h"
#define NUM_ENTRIES 10000
//#define CREATE_FILM
#ifdef CREATE_FILM
#include <bzlib.h>
static BZFILE *bzf;
static char con1=1,con2=2,con3=3;
#endif
extern char hif_fpsstr[];
typedef union {
struct {SDL_Surface *s1,*s2;SDL_Rect r1,r2;} blit;
struct {int no;SDL_Rect r1,r2;} stdblit;
struct {SDL_Surface *s;SDL_Rect r;Uint32 c;} fill;
} HIF_GRAPHICS_Entry;
typedef enum {HIF_BLIT,HIF_STDBLIT,HIF_FILL,HIF_HINTS,HIF_FPS} HIF_GRAPHICS_EntryType;
typedef struct {int no;char *c;} HIF_GRAPHICS_HINT;
typedef struct {
int num_entries;
char toupdate_panel,num_hints;
char *hints[48];
HIF_GRAPHICS_EntryType entry_types[NUM_ENTRIES];
HIF_GRAPHICS_Entry entries[NUM_ENTRIES];
} HIF_GRAPHICS_QUEUE;
static HIF_GRAPHICS_QUEUE queues[2];
static char unvisible_queue=0;
void HIF_GRAPHICS_Init(void)
{
int i;
for (i=0;i<2;i++){queues[i].num_entries=0;queues[i].toupdate_panel=0;queues[i].num_hints=0;};
#ifdef CREATE_FILM
bzf=BZ2_bzopen("film.bz2","w");
#endif
}
void HIF_BlitSurface(SDL_Surface *src,SDL_Rect *src_rect,SDL_Surface *dst,SDL_Rect *dst_rect)
{
if (src_rect!=NULL)if ((src_rect->x>src->w)||(src_rect->x+src_rect->w<0)||(src_rect->y>src->h)||(src_rect->y+src_rect->h<0))return;
if (dst_rect!=NULL)if ((dst_rect->x>dst->w)||(dst_rect->x+dst_rect->w<0)||(dst_rect->y>dst->h)||(dst_rect->y+dst_rect->h<0))return;
if (queues[unvisible_queue].num_entries==NUM_ENTRIES){fprintf(LOG,"Warning(hif_graphics.cpp): out of queue.\n");};
queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.s1=src;
if (src_rect!=NULL){queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.r1=*src_rect;}else
  {ASSIGNRECT(queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.r1,0,0,src->w,src->h);};
queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.s2=dst;
if (dst_rect!=NULL){queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.r2=*dst_rect;}else
  {ASSIGNRECT(queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].blit.r2,0,0,dst->w,dst->h);};
queues[unvisible_queue].entry_types[queues[unvisible_queue].num_entries]=HIF_BLIT;
queues[unvisible_queue].num_entries++;
}
void HIF_BlitStdSurface(int no,SDL_Rect *src,SDL_Rect *dst)
{
if (src!=NULL)if ((src->x>images[no]->w)||(src->y>images[no]->h)||(src->x+src->w<0)||(src->y+src->h<0))return;
if (dst!=NULL)if ((dst->x>640)||(dst->y>480)||(dst->x+dst->w<0)||(dst->y+dst->h<0))return;
if (queues[unvisible_queue].num_entries==NUM_ENTRIES){fprintf(LOG,"Warning(hif_graphics.cpp): out of queue.\n");};
queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].stdblit.no=no;
if (src!=NULL){queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].stdblit.r1=*src;}else
  {ASSIGNRECT(queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].stdblit.r1,0,0,images[no]->w,images[no]->h);};
if (dst!=NULL){queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].stdblit.r2=*dst;}else
  {ASSIGNRECT(queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].stdblit.r2,0,0,640,480);};
queues[unvisible_queue].entry_types[queues[unvisible_queue].num_entries]=HIF_STDBLIT;
queues[unvisible_queue].num_entries++;
}
void HIF_FillRect(SDL_Surface *surf,SDL_Rect *r,Uint32 col)
{
if (r!=NULL)if ((r->x>surf->w)||(r->x+r->w<0)||(r->y>surf->h)||(r->y+r->h<0))return;
if (queues[unvisible_queue].num_entries==NUM_ENTRIES){fprintf(LOG,"Warning(hif_graphics.cpp): out of queue.\n");};
queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].fill.s=surf;
if (r!=NULL){queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].fill.r=*r;}else
  {ASSIGNRECT(queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].fill.r,0,0,surf->w,surf->h);};
queues[unvisible_queue].entries[queues[unvisible_queue].num_entries].fill.c=col;
queues[unvisible_queue].entry_types[queues[unvisible_queue].num_entries]=HIF_FILL;
queues[unvisible_queue].num_entries++;
}
void HIF_ShowAllHints(void)
{
if (queues[unvisible_queue].num_entries==NUM_ENTRIES){fprintf(LOG,"Warning(hif_graphics.cpp): out of queue.\n");};
queues[unvisible_queue].entry_types[queues[unvisible_queue].num_entries]=HIF_HINTS;
queues[unvisible_queue].num_entries++;
}
void HIF_ShowFPS(void)
{
if (queues[unvisible_queue].num_entries==NUM_ENTRIES){fprintf(LOG,"Warning(hif_graphics.cpp): out of queue.\n");};
queues[unvisible_queue].entry_types[queues[unvisible_queue].num_entries]=HIF_FPS;
queues[unvisible_queue].num_entries++;
}
void HIF_Flip(void)
{
queues[unvisible_queue].toupdate_panel=hif_to_update_panel;
hif_to_update_panel=0;
unvisible_queue=1-unvisible_queue;
queues[unvisible_queue].num_hints=queues[unvisible_queue].num_entries=0;
}
void HIF_AddHintSurface(char *c)
{
if (queues[unvisible_queue].num_hints==48){fprintf(LOG,"Warning(hif_graphics.cpp): out of hints.\n");};
queues[unvisible_queue].hints[queues[unvisible_queue].num_hints]=c;
queues[unvisible_queue].num_hints++;
}
int HIF_UpdateScreen(void *nothing)
{
int i,i2;
while (hif_state.refresh_toquit==0){
SDL_SemWait(hif_state.sem_refr_allow);
if (hif_state.refresh_toquit==1)break;
for (i=0;i<queues[1-unvisible_queue].num_hints;i++)if (hif_level_info.numhints!=48){
  SDL_Surface *s=SDL_CreateRGBSurface(SDL_HWSURFACE,font->TextWidth(queues[1-unvisible_queue].hints[i]),8,32,SURFACE_COLOURS);
  SDL_FillRect(s,NULL,C_BLACK(s));
  font->OutText(0,0,C_WHITE(s),queues[1-unvisible_queue].hints[i],s);
  hif_level_info.hints[hif_level_info.numhints]=s;
  hif_level_info.hint_frames[hif_level_info.numhints]=HIF_HINT_FRAMES;
  hif_level_info.hint_y[hif_level_info.numhints]=480;
  hif_level_info.numhints++;
  };
//proceed hints
for (i=0;i<hif_level_info.numhints;i++)if (hif_level_info.hint_y[i]>i*10){hif_level_info.hint_y[i]-=10;}else{
  if ((hif_level_info.hint_frames[i]--)==0){
    SDL_FreeSurface(hif_level_info.hints[i]);for (i2=i;i2<hif_level_info.numhints-1;i2++){
      hif_level_info.hints[i2]=hif_level_info.hints[i2+1];
      hif_level_info.hint_y[i2]=hif_level_info.hint_y[i2+1];
      hif_level_info.hint_frames[i2]=hif_level_info.hint_frames[i2+1];};
    i--;hif_level_info.numhints--;};
};
if (queues[1-unvisible_queue].toupdate_panel==1)hif_updatepanel();
for (i=0;i<queues[1-unvisible_queue].num_entries;i++)switch (queues[1-unvisible_queue].entry_types[i]){
case HIF_BLIT:SDL_BlitSurface(queues[1-unvisible_queue].entries[i].blit.s1,&queues[1-unvisible_queue].entries[i].blit.r1,
                          queues[1-unvisible_queue].entries[i].blit.s2,&queues[1-unvisible_queue].entries[i].blit.r2);break;
case HIF_FILL:
#ifdef CREATE_FILM
if (queues[1-unvisible_queue].entries[i].fill.s==screen){
BZ2_bzwrite(bzf,&con1,1);
BZ2_bzwrite(bzf,&queues[1-unvisible_queue].entries[i].fill.r,sizeof(SDL_Rect));
BZ2_bzwrite(bzf,&queues[1-unvisible_queue].entries[i].fill.c,sizeof(Uint32));
};
#endif
SDL_FillRect(queues[1-unvisible_queue].entries[i].fill.s,&queues[1-unvisible_queue].entries[i].fill.r,
                                                        queues[1-unvisible_queue].entries[i].fill.c);break;
case HIF_HINTS:for (i2=0;i2<hif_level_info.numhints;i2++){
      SDL_Rect r1={640-hif_level_info.hints[i2]->w,hif_level_info.hint_y[i2],hif_level_info.hints[i2]->w,hif_level_info.hints[i2]->h};
      SDL_BlitSurface(hif_level_info.hints[i2],NULL,screen,&r1);};break;
case HIF_FPS:font->OutText(610,471,C_WHITE(screen),hif_fpsstr,screen);break;
case HIF_STDBLIT:
#ifdef CREATE_FILM
BZ2_bzwrite(bzf,&con2,1);
BZ2_bzwrite(bzf,&queues[1-unvisible_queue].entries[i].stdblit.no,sizeof(int));
BZ2_bzwrite(bzf,&queues[1-unvisible_queue].entries[i].stdblit.r1,sizeof(SDL_Rect));
BZ2_bzwrite(bzf,&queues[1-unvisible_queue].entries[i].stdblit.r2,sizeof(SDL_Rect));
#endif
SDL_BlitSurface(images[queues[1-unvisible_queue].entries[i].stdblit.no],&queues[1-unvisible_queue].entries[i].stdblit.r1,screen,
                          &queues[1-unvisible_queue].entries[i].stdblit.r2);
break;
};
#ifdef CREATE_FILM
BZ2_bzwrite(bzf,&con3,1);
#endif
SDL_Flip(screen);
SDL_SemPost(hif_state.sem_refr_ready);
};
return 0;
}
void HIF_GRAPHICS_Done()
{
#ifdef CREATE_FILM
BZ2_bzclose(bzf);
#endif
}
