#include "images.h"
#include "hif_main.h"
#include "sg.h"
#include "video.h"
#include "misc.h"
#include <string.h>
#include "hif_levels.h"
#include "locale.h"
#include <stdlib.h>
#include "sound.h"
#include "log.h"
#include <SDL/SDL_thread.h>
#define HIF_TEXT_STEP 5
HIF_STATE_STRUCT hif_state;
SDL_Surface *hif_texts[HIF_LAST_LOCALE-HIF_FIRST_LOCALE+1];
SDL_Surface *hif_fastwalks[2][HIF_NUM_VR];
Uint32 hif_last_time;
SDL_Thread *hif_thread;
char hif_toshowmap=0;
void hif_create_texts(void)
{
char n,i;
for(n=0;n<=HIF_LAST_LOCALE-HIF_FIRST_LOCALE;n++){
hif_texts[n]=SDL_CreateRGBSurface(SDL_SWSURFACE,font->TextWidth(_locale_[n+HIF_FIRST_LOCALE]),
            8*HIF_TEXT_NPHASES,32,SURFACE_COLOURS);
SDL_FillRect(hif_texts[n],NULL,C_BLACK(hif_texts[n]));
SDL_SetColorKey(hif_texts[n],SDL_SRCCOLORKEY|SDL_RLEACCEL,C_BLACK(hif_texts[n]));
for (i=1;i<HIF_TEXT_NPHASES;i++)
    font->OutText(0,i*8,SDL_MapRGB(hif_texts[n]->format,255-i*HIF_TEXT_STEP,255-i*HIF_TEXT_STEP,255-i*HIF_TEXT_STEP),
        _locale_[n+HIF_FIRST_LOCALE],hif_texts[n]);
};
}
int hif_level,hif_stillplaying,hif_victory;
extern int what_to_do;
HIF_PLAYER_INFO hif_player_info;
HIF_LEVEL_INFO hif_level_info;
int hif_ticks=0,hif_numevents;
HIF_EVENT hif_events[HIF_NUM_EVENTS];
SDL_Surface *hif_panel,*hif_map;
HIF_BUTTON_HANDLER *hif_handler;
void hif(int save_no)
{
char i;
//Uint32 t=0,t2=0;
fprintf(LOG,"HIF start.\n");
log_block[0]=LOG_HIF;log_block[1]=LOG_HIF_INIT;
memset(&hif_level_info,0,sizeof(hif_level_info));memset(&hif_player_info,0,sizeof(hif_player_info));
hif_create_texts();
hif_panel=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,640,8,32,SURFACE_COLOURS);
if (save_no==WHAT_FIRSTLEVEL){showvideo(VIDEO_HIF+save_no-WHAT_FIRSTLEVEL);
hif_loadlevel(0);hif_level=0;hif_player_info.health=100;memset(hif_player_info.weapons,0,9*sizeof(int));
hif_player_info.vy=0;memset(hif_player_info.keys,0,3*sizeof(int));
hif_player_info.weapons[0]=1;
hif_handler(HIF_LEVHAND_INIT,0,NULL,0,0);
}else{hif_loadsg(save_no);};
if ((hif_state.sem_refr_allow=SDL_CreateSemaphore(0))==NULL)fprintf(LOG,"Error creating semaphore.\n");
if ((hif_state.sem_refr_ready=SDL_CreateSemaphore(0))==NULL)fprintf(LOG,"Error creating semaphore.\n");
hif_state.refresh_toquit=0;
hif_stillplaying=1;hif_victory=0;
hif_updatepanel();
hif_thread=SDL_CreateThread(&HIF_UpdateScreen,NULL);
while (hif_stillplaying==1){
hif_numevents=0;
fprintf(LOG,"HIF small cycle:\n");
SND_PlayExtraMusic();
hif_lasttime2=SDL_GetTicks();
misc_getkeyboard();hif_player_info.air=1000;
hif_player_info.state=HIF_STATE_WALKING;
memset(&(hif_keys_pressed[0]),0,HIF_NUM_KEYS);
misc_getkeyboard();
HIF_GRAPHICS_Init();
while ((hif_victory==0)&&(hif_stillplaying==1)){
//extern SDL_Surface *fps_surf;
//SDL_Rect r1={hif_level_info.numthings,0,1,1};
SDL_SemPost(hif_state.sem_refr_allow);
hif_proceed();hif_refresh();
SDL_SemWait(hif_state.sem_refr_ready);

//t2=SDL_GetTicks();r1.y=t2-t;t=t2;SDL_FillRect(fps_surf,&r1,C_WHITE(fps_surf));

hif_ticks++;
HIF_Flip();
};
SND_StopMusic();
SDL_FreeSurface(hif_map);
hif_handler(HIF_LEVHAND_DEINIT,0,NULL,0,0);
free(hif_level_info.thing_map);
free(hif_level_info.thing_map_rest);
fprintf(LOG,"HIF small cycle successfull.\n");
for (i=0;i<hif_level_info.numvents;i++){SDL_FreeSurface(hif_fastwalks[0][i]);};
for (i=0;i<hif_level_info.numrivers;i++){SDL_FreeSurface(hif_fastwalks[1][i]);};
for (i=0;i<hif_level_info.numenemies;i++){delete hif_level_info.enemies[i];};
if (hif_victory!=0)
    {hif_level++;hif_victory=0;if (hif_level==HIF_NUM_OF_LEVELS)
        {hif_stillplaying=0;what_to_do=WHAT_FIRSTLEVEL+1;}else{hif_loadlevel(hif_level);showvideo(hif_level+VIDEO_HIF);hif_stillplaying=1;
          hif_handler(HIF_LEVHAND_INIT,0,NULL,0,0);};
    };
};
log_block[1]=LOG_HIF_DONE;
hif_state.refresh_toquit=1;
SDL_SemPost(hif_state.sem_refr_allow);
SDL_WaitThread(hif_thread,NULL);
SDL_DestroySemaphore(hif_state.sem_refr_allow);
SDL_DestroySemaphore(hif_state.sem_refr_ready);
SDL_FreeSurface(hif_panel);
for (i=0;i<HIF_LAST_LOCALE-HIF_FIRST_LOCALE+1;i++){SDL_FreeSurface(hif_texts[i]);};
fprintf(LOG,"HIF - quit\n");
}
