#ifndef _HIF_MAIN_H_
#define _HIF_MAIN_H_
#include <math.h>
#include <stdlib.h>
#include "hif_levels.h"
#include "hif_classes.h"
#include <SDL/SDL.h>
#include <SDL/SDL_mutex.h>
#include "locale.h"
#include <bzlib.h>
#include "hif_graphics.h"
void hif_refresh(void);
void hif_proceed(void);
void hif_loadlevel(int no);
void hif_loadsg(char no);
void hif_savesg(char no);
#define HIF_NUM_OF_LEVELS 6
#define HIF_LEVEL_MAPSIZE 10000
#define HIF_NUM_THINGS 10000
#define HIF_NUM_VR 80
#define HIF_NUM_AIR 40
#define HIF_BEE_MAXBEER 3000
#define HIF_BEE_HALFXSIZE 15
#define HIF_BEE_HALFYSIZE 11
#define HIF_BEE_NOQUITTIME 20
#define HIF_BEE_IMAGE (_IMG_hif_bee_left+hif_level_info.bee.is_right)
#define HIF_BEE_FLYING 0
#define HIF_BEE_DYING 2
#define HIF_BEE_FALLING 3
#define HIF_BEE_OVERTURNING 4
#define HIF_BEE_RISING 5
#define HIF_BEE_DEAD 6
#define HIF_BEE_BREATHING 7
#define HIF_BEE_PREROTATING 8
#define HIF_BEE_DRINKING 10
#define HIF_BEE_DRINKING_ 50
#define HIF_BEE_OVERTURNING_ 20
#define HIF_BEE_BREATHING_ 40
#define HIF_BEE_PREROTATING_ 30
#define HIF_ENEMY_GHOST 0
#define HIF_ENEMY_SNAIL 1
#define HIF_ENEMY_CAR 2
#define HIF_ENEMY_GUN 3
#define HIF_ENEMY_PANK 6
#define HIF_ENEMY_DROID 7
#define HIF_ENEMY_FLOWER 8
#define HIF_ENEMY_BIGBEE 9
#define HIF_ENEMY_MAD 10
#define HIF_NUM_ENEMIES 80
#define HIF_NUM_LINES 500
#define HIF_LINES_NUMPHASES 120
#define HIF_NUM_BLOCKS 80
#define HIF_NUM_BLOCKS_D 100
#define HIF_BLOCK_WHITEWALL 0
#define HIF_BLOCK_METALWALLV 1
#define HIF_BLOCK_METALWALLH 2
#define HIF_NUM_DROPS 50
#define HIF_NUM_MISC 100
#define HIF_NUM_FIREBALLS 50
#define HIF_BEE_FIRETIME 2
#define HIF_FIREBALL_NUMPHASES 10
#define HIF_FIREBALL_DAMAGE 5
#define HIF_NUM_SCTH 100
#define HIF_HINT_FRAMES 600
typedef enum {
HIF_STATE_WALKING,
HIF_STATE_PRESSING
} HIF_STATE;
typedef enum {HIF_PANEL_NONE,HIF_PANEL_HERE,HIF_PANEL_SHOWING,HIF_PANEL_HIDING} HIF_APANEL_STATE;
typedef struct HIF_PLAYER_INFO HIF_PLAYER_INFO;
struct HIF_PLAYER_INFO {
int x,y,health,weapons[9],keys[3],vy,num_prebeer,t_drank,air;
char size,oldsize,weapon,shootdelay,direction,phase,in_keeper;
HIF_STATE state;
HIF_APANEL_STATE apanel_state;
float apanel_pos;
int apanel_phase,butt_x,butt_y;
char apanel_opts[6];
long river_offs,vent_offs,in_river,in_vent,scores;
};
extern HIF_PLAYER_INFO hif_player_info;
typedef struct HIF_LEVEL_INFO HIF_LEVEL_INFO;
struct HIF_LEVEL_INFO {
int xsize,ysize,numdrops,numthings,numthings_rest;
Sint16 numvents,numrivers,numenemies,numfireballs,numblocks,numblocks_real,numlines,numscth,numhints,numair;
Sint16 bg[HIF_LEVEL_MAPSIZE],fg[HIF_LEVEL_MAPSIZE],walls[HIF_LEVEL_MAPSIZE],keepers[HIF_LEVEL_MAPSIZE];
int delta_x0,delta_y0;
char map[HIF_LEVEL_MAPSIZE];
int *thing_map,*thing_map_rest;
CHIF_Drop drops[HIF_NUM_DROPS];
CHIF_Thing things[HIF_NUM_THINGS],things2[HIF_NUM_THINGS],things_rest[HIF_NUM_THINGS];
CHIF_Vent vents[HIF_NUM_VR];
CHIF_River rivers[HIF_NUM_VR];
CHIF_Fireball fireballs[HIF_NUM_FIREBALLS];
CHIF_Bee bee;
CHIF_Line lines[HIF_NUM_LINES];
CHIF_Block blocks[HIF_NUM_BLOCKS];
CHIF_Air air[HIF_NUM_AIR];
CHIF_Enemy *enemies[HIF_NUM_ENEMIES];
CHIF_ScTh scth[HIF_NUM_SCTH];
SDL_Surface *hints[48];
Uint16 hint_frames[48],hint_y[48];
};
extern HIF_LEVEL_INFO hif_level_info;
extern SDL_Surface *hif_fastwalks[2][HIF_NUM_VR];
extern int hif_ticks;
extern int hif_level,hif_stillplaying,hif_victory;
#define HIF_THING_REDKEY 0
#define HIF_THING_GREENKEY 1
#define HIF_THING_BLUEKEY 2
#define HIF_THING_COLA 3
#define HIF_THING_FOOD 4
#define HIF_THING_FIRSTSHELL 5
#define HIF_THING_TRAP 10
#define HIF_THING_TRAPOFF 13
#define HIF_THING_COIN 14
#define HIF_THING_TRAPMINE 15
#define HIF_THING_PREBEER 16
#define HIF_THING_TRAPOFFMINE 17
#define HIF_THING_DOT 18
#define HIF_SIZES_NUM 4
extern int hif_sizes[HIF_SIZES_NUM][4];
void hif_updatepanel(void);
extern SDL_Surface *hif_panel;
typedef struct HIF_EVENT HIF_EVENT;
struct HIF_EVENT {char type,phase;Uint16 image1,image2;Uint16 x,y;};
#define HIF_EVENT_TEXT 0
#define HIF_EVENT_TWOIMAGES 1
#define HIF_EVENT_ENEMY_DYING 4
#define HIF_EVENT_DOORPHASES 5
#define HIF_NUM_EVENTS 100
#define HIF_TEXT_NPHASES 50
extern HIF_EVENT hif_events[HIF_NUM_EVENTS];
extern int hif_numevents;
#define MAX(x,y) (((x)>(y))?(x):(y))
#define MIN(x,y) (((x)>(y))?(y):(x))
#define SGN(x) (((x)==0)?(0):(((x)>0)?(1):(-1)))
extern HIF_BUTTON_HANDLER *hif_handler;
extern SDL_Surface *hif_texts[HIF_LAST_LOCALE-HIF_FIRST_LOCALE+1];
void hif_help(void);
#define HIF_NUM_KEYS 6
extern char hif_keys_pressed[HIF_NUM_KEYS];
void hif_things_inc(char n);
#define HIF_ENEMY_SIZE(no,si) ((si<2)?(-19):(19))
#define HIF_ENEMY_HEALTH(no) (90)
//#define HIF_ENEMY_DEADPHASES(no) (((no)==1)?(6):(10))
#define HIF_ENEMY_DEADPHASES(no) 7
#define HIF_ENEMY_DAMAGE(t) ((((t)==HIF_ENEMY_CAR)||((t)==HIF_ENEMY_SNAIL)||((t)==HIF_ENEMY_PANK)||\
  ((t)==HIF_ENEMY_BIGBEE) )?(1):(0))
#define HIF_TRAP_DAMAGE 1
extern Uint32 hif_last_time;
#define HIF_SLEEP_SMALL 250
#define HIF_SLEEP_BIG 2500
#define HIF_MISC_BUG 0
#define HIF_MISC_AIR 1
#define HIF_DRANK_QUATER 8
extern float hif_lasttime2;
extern const char hif_apanel_times[6];
extern char hif_to_update_panel;
//from hif_proceed.c
int hif_proceed_smb_cango(int nx,int ny,int x1,int y1,int x2,int y2);
#define hif_proceed_cango(a,b) hif_proceed_smb_cango(hif_player_info.x+(a),hif_player_info.y+(b),hif_sizes[hif_player_info.size][0], \
  hif_sizes[hif_player_info.size][1],hif_sizes[hif_player_info.size][2],hif_sizes[hif_player_info.size][3])
#define hif_proceed_bee_cango(a,b) hif_proceed_smb_cango((int)(a),(int)(b),-HIF_BEE_HALFXSIZE,-HIF_BEE_HALFYSIZE,HIF_BEE_HALFXSIZE,\
  HIF_BEE_HALFYSIZE)
double floor(double a);
#define hif_proceed_can_thing(a,b) hif_proceed_smb_cango((int)(a),(int)(b),-2,-2,2,2)
#define hif_proceed_enemy_cango(a,b,t) hif_proceed_smb_cango(a,b,HIF_ENEMY_SIZE(t,0),HIF_ENEMY_SIZE(t,1),HIF_ENEMY_SIZE(t,2),\
    HIF_ENEMY_SIZE(t,3))
int hif_proceed_trytogo(int nx,int ny);
extern const char hif_nose[HIF_SIZES_NUM][2];
extern const char hif_weapon_damages[9];
extern const char hif_directions[4][2];
void hif_add_text(int x,int y,Uint16 no);
void hif_proceed_explode_no(int i,char from_mine);//1 - from mine, 0 - from n_mines in enemy
#define HIF_FLOWER_DIST 100
extern SDL_Surface *hif_map;
extern char hif_toshowmap;
extern const char hif_mapC[6][3];
int hif_register_thing(float x_,float y_, float vx_, float vy_,int no_,char type_,char is_hurting_,char is_lonely_);
void hif_unregister_thing(int no);
int hif_register_thing_rest(float x_,float y_, float vx_, float vy_,int no_,char type_,char is_hurting_,char is_lonely_);
void hif_unregister_thing_rest(int no);
Sint16 *hif_get_thing(Sint16 *t);
//threading
typedef struct {
char refresh_toquit;
SDL_sem *sem_refr_allow,*sem_refr_ready;
} HIF_STATE_STRUCT;
extern HIF_STATE_STRUCT hif_state;
#define HIF_INFO_DIST 250
#define HIF_PANEL_NUMPHASES 28
#endif
