#define MU 1.05
#include "locale.h"
#include "images.h"
#include "hif_main.h"
#include "sg.h"
#include <SDL/SDL.h>
#include <SDL/SDL_keysym.h>
#include "misc.h"
#include "gamemenu.h"
#include "math.h"
#include <stdlib.h>
#include <string.h>
#include "sound.h"
#include "video.h"
#include "log.h"
#include "scrsaver.h"
#define SQR(a) ((a)*(a))
#define MAKEDIFF(a,b,c,d,e) if (a<=b){c-=e;d+=e;}else{c+=e;d-=e;};
#define HIF_REFRESH_DOORIMAGE_ANI 4
#define HIF_VELOCITY ((hif_player_info.size<2)?(2):(hif_player_info.size+1))
#define HIF_CHANGE_HED_PHASE if (hif_player_info.size!=3){hif_player_info.phase=(hif_player_info.phase+1)%3;}else{\
  if (hif_ticks%2==0)hif_player_info.phase=(hif_player_info.phase-(2*hif_player_info.direction-1)+4)%4;}
#define HIF_JUMP_KOEF ((hif_player_info.size==3)?(1.5):(3))
#define HIF_PANEL_KOEF (1.2)
#define HIF_CATCH_DIST 500
#define HIF_BEER_HEALTH 70
extern int what_to_do;
char hif_keys_pressed[HIF_NUM_KEYS];
//up,right,down,left,fire,push[button]
int hif_sizes[HIF_SIZES_NUM][4]={{-10,-16,11,19},{-10,-1,10,19},{-16,0,17,19},{-10,-10,11,12}};//dx1,dy1,dx2,dy2
const char hif_weapon_damages[9]={1,3,4,8,0,0,40,0,0};
const char hif_weapon_delays[9]={0,10,8,12,8,8,8,22,10};
const char hif_directions[4][2]={{1,0},{0,-1},{-1,0},{0,1}};
const char hif_apanel_times[6]={10,10,10,10,10,10};
const char hif_nose[HIF_SIZES_NUM][2]={{9,-7},{9,3},{15,12},{0,0}};//coord if right
char hif_in_vent,hif_to_update_panel=0;
void hif_proceed_two_things(CHIF_Thing *t1,CHIF_Thing *t2)
{
if ((t1->is_hurting<0)||(t2->is_hurting<0)||(t1->is_lonely==2)||(t2->is_lonely==2))return;
if ((abs((int)(t1->x-t2->x))<=4)&&(abs((int)(t1->y-t2->y))<=4))
  {
if ((t1->type!=t2->type)||(t1->is_hurting!=t2->is_hurting)||(t1->is_lonely==1)||(t2->is_lonely==1)){
float f1=20+rand()%100,f2=20+rand()%100,v=sqrt(SQR(t1->vx+t2->vx)+SQR(t1->vy+t2->vy));
float k=f1/(f1+f2),u1=rand(),u2=rand();
t1->vx=sin(u1)*v*k;t1->vy=cos(u1)*v*k;
t2->vx=sin(u2)*v*(1-k);t2->vy=cos(u2)*v*(1-k);
MAKEDIFF(t1->x,t2->x,t1->vx,t2->vx,1);MAKEDIFF(t1->y,t2->y,t1->vy,t2->vy,1);
/*
   if (t1->vx*t2->vx==0)
      {float k=t1->vx;t1->vx=t2->vx;t2->vx=k;MAKEDIFF(t1->x,t2->x,t1->vx,t2->vx,1);}
    else{t1->vx=t2->vx=(t1->vx+t2->vx)/2;MAKEDIFF(t1->x,t2->x,t1->vx,t2->vx,1);
};
   if (t1->vy*t2->vy==0)
      {float k=t1->vy;t1->vy=t2->vy;t2->vy=k;MAKEDIFF(t1->y,t2->y,t1->vy,t2->vy,1);}
    else{t1->vy=t2->vy=(t1->vy+t2->vy)/2;MAKEDIFF(t1->y,t2->y,t1->vy,t2->vy,1);};
*/
} else {
    t1->vy=(t1->vy+t2->vy)/2;t1->vx=(t1->vx+t2->vx)/2;t1->no+=t2->no;t2->is_hurting=-1;};
};
}
void hif_proceed_two_cells(int c1,int c2)
{
int i,i2;
for (i=hif_level_info.thing_map[c1];i<hif_level_info.thing_map[c1+1];i++)
  for (i2=hif_level_info.thing_map_rest[c2];i2<hif_level_info.thing_map_rest[c2+1];i2++)
    hif_proceed_two_things(&(hif_level_info.things[i]),&(hif_level_info.things_rest[i2]));
for (i=hif_level_info.thing_map[c2];i<hif_level_info.thing_map[c2+1];i++)
  for (i2=hif_level_info.thing_map_rest[c1];i2<hif_level_info.thing_map_rest[c1+1];i2++)
    hif_proceed_two_things(&(hif_level_info.things[i]),&(hif_level_info.things_rest[i2]));
}
int hif_register_thing(float x_,float y_, float vx_, float vy_,int no_,char type_,char is_hurting_,char is_lonely_)
{
int a=(((int)x_)/40+(((int)y_)/40)*(hif_level_info.xsize)),n,min,max,a2,n2;
if (hif_level_info.numthings==0){n=0;}else{
 if (a>=hif_level_info.things[hif_level_info.numthings-1].cell){n=hif_level_info.numthings;}else{
  if (a<=hif_level_info.things[0].cell){n=0;}else{
   min=1;max=hif_level_info.numthings-1;
   while (1){
    if (max-min<=1){if ((hif_level_info.things[min-1].cell<=a)&&(a<=hif_level_info.things[min].cell)){n=min;}else{n=max;};break;};
    if (hif_level_info.things[max].cell==a){n=max;break;};
    if (hif_level_info.things[min].cell==a){n=min;break;};
    n2=(min+max)/2;a2=hif_level_info.things[n2].cell;
    if (a2==a){n=n2;break;};
    if (a2<a){min=n2;}else{max=n2;};
  };};};};
if (n!=hif_level_info.numthings)memmove(&(hif_level_info.things[n+1]),&(hif_level_info.things[n]),sizeof(CHIF_Thing)*(hif_level_info.numthings-n));
hif_level_info.things[n].x=x_;
hif_level_info.things[n].y=y_;
hif_level_info.things[n].vx=vx_;
hif_level_info.things[n].vy=vy_;
hif_level_info.things[n].no=no_;
hif_level_info.things[n].type=type_;
hif_level_info.things[n].is_hurting=is_hurting_;
hif_level_info.things[n].cell=a;
hif_level_info.things[n].is_lonely=is_lonely_;
hif_level_info.things[n].is_resting=0;
hif_level_info.numthings++;
return n;
}
void hif_unregister_thing(int no)
{
int n=hif_level_info.numthings-1-no;
if (n!=0)memmove(&(hif_level_info.things[no]),&(hif_level_info.things[no+1]),n*sizeof(CHIF_Thing));
hif_level_info.numthings--;
}
int hif_register_thing_rest(float x_,float y_, float vx_, float vy_,int no_,char type_,char is_hurting_,char is_lonely_)
{
int a=(((int)x_)/40+(((int)y_)/40)*(hif_level_info.xsize)),n,min,max,a2,n2;
if (hif_level_info.numthings_rest==0){n=0;}else{
 if (a>=hif_level_info.things_rest[hif_level_info.numthings_rest-1].cell){n=hif_level_info.numthings_rest;}else{
  if (a<=hif_level_info.things_rest[0].cell){n=0;}else{
   min=1;max=hif_level_info.numthings_rest-1;
   while (1){
    if (max-min<=1){if ((hif_level_info.things_rest[min-1].cell<=a)&&(a<=hif_level_info.things_rest[min].cell)){n=min;}else{n=max;};break;};
    if (hif_level_info.things_rest[max].cell==a){n=max;break;};
    if (hif_level_info.things_rest[min].cell==a){n=min;break;};
    n2=(min+max)/2;a2=hif_level_info.things_rest[n2].cell;
    if (a2==a){n=n2;break;};
    if (a2<a){min=n2;}else{max=n2;};
  };};};};
if (n!=hif_level_info.numthings_rest)
  memmove(&(hif_level_info.things_rest[n+1]),&(hif_level_info.things_rest[n]),sizeof(CHIF_Thing)*(hif_level_info.numthings_rest-n));
hif_level_info.things_rest[n].x=x_;
hif_level_info.things_rest[n].y=y_;
hif_level_info.things_rest[n].vx=vx_;
hif_level_info.things_rest[n].vy=vy_;
hif_level_info.things_rest[n].no=no_;
hif_level_info.things_rest[n].type=type_;
hif_level_info.things_rest[n].is_hurting=is_hurting_;
hif_level_info.things_rest[n].cell=a;
hif_level_info.things_rest[n].is_lonely=is_lonely_;
hif_level_info.things_rest[n].is_resting=1;
hif_level_info.numthings_rest++;
return n;
}
void hif_unregister_thing_rest(int no)
{
int n=hif_level_info.numthings_rest-1-no;
if (n!=0)memmove(&(hif_level_info.things_rest[no]),&(hif_level_info.things_rest[no+1]),n*sizeof(CHIF_Thing));
hif_level_info.numthings_rest--;
}
Sint16 *hif_get_thing(Sint16 *t)
{
Sint16 x_,y_,type_,no_;
x_=*t++;y_=*t++;type_=*t++;no_=*t++;hif_register_thing(x_,y_,0,0,no_,type_,0,0);return t;
}
void hif_add_text(int x,int y,Uint16 no)
{
#define HIF_TEXT_WIDTH 180
#define HIF_TEXT_STEP 5
if (hif_numevents<HIF_NUM_EVENTS){
hif_events[hif_numevents].x=hif_player_info.x+x;hif_events[hif_numevents].y=hif_player_info.y+y;
hif_events[hif_numevents].phase=HIF_TEXT_NPHASES;hif_events[hif_numevents].type=HIF_EVENT_TEXT;
hif_events[hif_numevents].image1=no-HIF_FIRST_LOCALE;
hif_numevents++;};
}
void hif_proceed_catchshells(char just_traps)
{
int i;
for (i=0;i<hif_level_info.numthings;i++)
if (((hif_level_info.things[i].is_hurting<2)&&(just_traps==0))||(((hif_level_info.things[i].type==HIF_THING_FIRSTSHELL+5)||
                        (hif_level_info.things[i].type==HIF_THING_TRAPMINE))&&(just_traps==1)))
  if (SQR(hif_player_info.x-hif_level_info.things[i].x)+SQR(hif_player_info.y-hif_level_info.things[i].y)<SQR(HIF_CATCH_DIST))
  {if (just_traps==0){if ((hif_level_info.things[i].type!=HIF_THING_TRAPMINE)&&(hif_level_info.things[i].type!=HIF_THING_FIRSTSHELL+5))
                                      hif_level_info.things[i].is_hurting=2;}else{
 hif_level_info.things[i].type=((hif_level_info.things[i].type==HIF_THING_FIRSTSHELL+5)?(HIF_THING_TRAPOFF):(HIF_THING_TRAPOFFMINE));};};
for (i=0;i<hif_level_info.numthings_rest;i++)
if (((hif_level_info.things_rest[i].is_hurting<2)&&(just_traps==0))||(((hif_level_info.things_rest[i].type==HIF_THING_FIRSTSHELL+5)||
                        (hif_level_info.things_rest[i].type==HIF_THING_TRAPMINE))&&(just_traps==1)))
  if (SQR(hif_player_info.x-hif_level_info.things_rest[i].x)+SQR(hif_player_info.y-hif_level_info.things_rest[i].y)<SQR(HIF_CATCH_DIST))
 {if (just_traps==0){if ((hif_level_info.things_rest[i].type!=HIF_THING_TRAPMINE)&&(hif_level_info.things_rest[i].type!=HIF_THING_FIRSTSHELL+5))
                                      hif_level_info.things_rest[i].is_hurting=2;}else{
 hif_level_info.things_rest[i].type=((hif_level_info.things_rest[i].type==HIF_THING_FIRSTSHELL+5)
      ?(HIF_THING_TRAPOFF):(HIF_THING_TRAPOFFMINE));};};
}
void hif_proceed_opendoor_at(int x,int y)
{
char t=0;
switch(hif_level_info.walls[x+y*hif_level_info.xsize])
{
case 3:if (hif_player_info.keys[0]>0){hif_player_info.keys[0]--;t=1;};break;
case 5:if (hif_player_info.keys[1]>0){hif_player_info.keys[1]--;t=2;};break;
case 7:if (hif_player_info.keys[2]>0){hif_player_info.keys[2]--;t=3;};break;
};
if (t!=0){
hif_add_text(x*20+10-hif_player_info.x/2,y*20+10-hif_player_info.y/2,_LOCALE_HIF_OPENDOOR);
if (hif_numevents<HIF_NUM_EVENTS){
hif_events[hif_numevents].type=HIF_EVENT_TWOIMAGES+1;hif_events[hif_numevents].phase=HIF_EVENT_DOORPHASES;
hif_events[hif_numevents].x=x;hif_events[hif_numevents].y=y;
hif_events[hif_numevents].image1=HIF_REFRESH_DOORIMAGE_ANI+(hif_level_info.walls[x+y*hif_level_info.xsize]-3)/2;
hif_events[hif_numevents].image2=0;hif_numevents++;};
hif_level_info.walls[x+y*hif_level_info.xsize]=0;
};
}
void hif_proceed_opendoor(void)
{
int k_old[3]={hif_player_info.keys[0],hif_player_info.keys[1],hif_player_info.keys[2]},a,b,c;
for (a=0;a<3;a+=2)for (b=0;b<3;b+=2)for (c=-1;c<2;c+=2){
hif_proceed_opendoor_at
      ((hif_player_info.x+hif_sizes[hif_player_info.size][a])/40+c,(hif_player_info.y+hif_sizes[hif_player_info.size][1+b])/40);
hif_proceed_opendoor_at
      ((hif_player_info.x+hif_sizes[hif_player_info.size][a])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][1+b])/40+c);
};
if ((k_old[0]!=hif_player_info.keys[0])||(k_old[1]!=hif_player_info.keys[1])||(k_old[2]!=hif_player_info.keys[2]))hif_to_update_panel=1;
}
void hif_proceed_cell(int x,int y)
{
switch (hif_level_info.walls[x+y*hif_level_info.xsize]){
case 2:case 4:case 6:hif_player_info.health-=hif_level_info.walls[x+y*hif_level_info.xsize]/2;
if (hif_player_info.health%3==0){
hif_add_text(25-100*(hif_ticks%2),-10-5*(hif_ticks%5),_LOCALE_HIF_HURTED);}hif_to_update_panel=1;break;
case 8:if (hif_player_info.size<2){if (hif_level_info.bee.enabled==0){hif_victory=1;hif_stillplaying=0;} else
                  {if (hif_ticks%5==0)hif_add_text(25,-20,_LOCALE_HIF_BEE_NOQUIT);};}else
                  {if (hif_ticks%5==0)hif_add_text(25,-20,_LOCALE_HIF_GETUP);};break;
//add another things
};
}
int hif_proceed_smb_cango(int nx,int ny,int x1,int y1,int x2,int y2)
{
char i;
if((hif_level_info.walls[((ny+y1)/40)*hif_level_info.xsize+((nx+x1)/40)]%2==0)&&
  (hif_level_info.walls[((ny+y2)/40)*hif_level_info.xsize+((nx+x1)/40)]%2==0)&&
  (hif_level_info.walls[((ny+y1)/40)*hif_level_info.xsize+((nx+x2)/40)]%2==0)&&
  (hif_level_info.walls[((ny+y2)/40)*hif_level_info.xsize+((nx+x2)/40)]%2==0)){for (i=0;i<hif_level_info.numblocks_real;i++)if (
      (MIN(ny+y2,hif_level_info.blocks[i].y2)>=MAX(ny+y1,hif_level_info.blocks[i].y1))&&
      (MIN(nx+x2,hif_level_info.blocks[i].x2)>=MAX(nx+x1,hif_level_info.blocks[i].x1)))return(-1);return(0);}else{return -1;};
}
int hif_proceed_trytogo(int nx,int ny)
{
if (hif_proceed_cango(nx,ny)==0){hif_player_info.x+=nx;hif_player_info.y+=ny;return 0;}else{return -1;};
}
void hif_proceed_explode_no(int i,char from_mine)
{
int i2,n0=hif_level_info.things[i].no;
float x0=hif_level_info.things[i].x,y0=hif_level_info.things[i].y;
char num[3]={0,0,0};
int i2_=0;
hif_unregister_thing(i);
num[0]=num[1]=num[2]=0;for (i2=0;i2<40;i2++){
if(hif_proceed_can_thing(x0+25*from_mine*cos(i2*PI/20),y0+25*from_mine*sin(i2*PI/20))==0){
  if (hif_level_info.numthings<HIF_NUM_THINGS){
  hif_register_thing(x0+25*from_mine*cos(i2*PI/20),y0+25*from_mine*sin(i2*PI/20),
             from_mine*10*cos(i2*PI/20),from_mine*10*sin(i2*PI/20),n0,HIF_THING_FIRSTSHELL+i2%3,1,0);};}else{num[i2%3]++;};};
      for(i2=0;i2<3;i2++)if (num[i2]!=0){ if (hif_level_info.numthings<HIF_NUM_THINGS)
  if (hif_proceed_can_thing(x0,y0)==0)hif_register_thing(x0,y0,0,0,n0*num[i2],HIF_THING_FIRSTSHELL+i2,1,0);
};
i2_=0;
}
void hif_proceed_shootdot()
{
if ((hif_proceed_can_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),hif_player_info.y+5)==0)&&
            (hif_level_info.numthings<HIF_NUM_THINGS)){
hif_register_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),hif_player_info.y+5,
          5*(2*hif_player_info.direction-1)+hif_keys_pressed[1]-hif_keys_pressed[3],hif_player_info.vy/3,1,HIF_THING_DOT,1,0);};
}
void hif_proceed_explode(void)
{
int i;
for (i=0;i<hif_level_info.numthings;i++)if (hif_level_info.things[i].type==HIF_THING_FIRSTSHELL+6)
  if(SQR(hif_player_info.x-hif_level_info.things[i].x)+SQR(hif_player_info.y-hif_level_info.things[i].y)<320*320+240*240)
    {hif_proceed_explode_no(i--,1);};
for (i=0;i<hif_level_info.numenemies;i++)if ((hif_level_info.enemies[i]->health>0)&&(hif_level_info.enemies[i]->n_mines>0)&&
  (SQR(hif_level_info.enemies[i]->x-hif_player_info.x)+SQR(hif_level_info.enemies[i]->y-hif_player_info.y)<320*320+240*240)){
hif_proceed_explode_no(hif_register_thing(hif_level_info.enemies[i]->x,hif_level_info.enemies[i]->y+
      HIF_ENEMY_SIZE(hif_level_info.enemies[i]->type,3)-4,0,0,hif_level_info.enemies[i]->n_mines,0,0,0),0);
hif_level_info.enemies[i]->n_mines=0;
};
}
void hif_proceed_chsize(char new_si)
{
char old_si=hif_player_info.size;
hif_player_info.size=new_si;
if (hif_proceed_trytogo(0,0)!=0){
 if (hif_proceed_trytogo(hif_sizes[old_si][0]-hif_sizes[new_si][0],0)!=0){
   if (hif_proceed_trytogo(hif_sizes[old_si][2]-hif_sizes[new_si][2],0)!=0){
    if (hif_proceed_trytogo(0,hif_sizes[old_si][1]-hif_sizes[new_si][1])!=0){
     if (hif_proceed_trytogo(0,hif_sizes[old_si][3]-hif_sizes[new_si][3])!=0){
       if (hif_proceed_trytogo(hif_sizes[old_si][0]-hif_sizes[new_si][0],hif_sizes[old_si][1]-hif_sizes[new_si][1])!=0){
        if (hif_proceed_trytogo(hif_sizes[old_si][0]-hif_sizes[new_si][0],hif_sizes[old_si][3]-hif_sizes[new_si][3])!=0){
         if (hif_proceed_trytogo(hif_sizes[old_si][2]-hif_sizes[new_si][2],hif_sizes[old_si][1]-hif_sizes[new_si][1])!=0){
          if (hif_proceed_trytogo(hif_sizes[old_si][2]-hif_sizes[new_si][2],hif_sizes[old_si][3]-hif_sizes[new_si][3])!=0){
      hif_player_info.size=old_si;};};};};};};};};};
}
void hif_proceed(void)
{
SDL_Event event;
int i,i2,i3;
long hif_offs;
static CHIF_Thing temp_thing;
//static Uint32 t1=0,t2=0;
log_block[1]=LOG_HIF_PROCEED;
hif_to_update_panel=0;
log_block[2]=0;
//proceed hif_state
switch (hif_player_info.state){
case HIF_STATE_PRESSING:if ((--hif_player_info.phase)==0){hif_player_info.state=HIF_STATE_WALKING;
                              hif_handler(HIF_LEVHAND_BUTTON,hif_player_info.butt_y*hif_level_info.xsize+hif_player_info.butt_x,NULL,0,0);};break;
default:break;
};
if (hif_player_info.t_drank>0)hif_player_info.t_drank--;
//do hif events
for (i=0;i<hif_numevents;i++){if ((--hif_events[i].phase)==0){
switch(hif_events[i].type){
case HIF_EVENT_TWOIMAGES:hif_level_info.bg[hif_level_info.xsize*hif_events[i].y+hif_events[i].x]=hif_events[i].image2;break;
case HIF_EVENT_TWOIMAGES+1:hif_level_info.walls[hif_level_info.xsize*hif_events[i].y+hif_events[i].x]=hif_events[i].image2;break;
case HIF_EVENT_TWOIMAGES+2:hif_level_info.fg[hif_level_info.xsize*hif_events[i].y+hif_events[i].x]=hif_events[i].image2;break;
};
hif_events[i]=hif_events[hif_numevents-1];hif_numevents--;};};
log_block[2]=1;
//proceed sdl events
while (SDL_PollEvent(&event))switch(event.type){
case SDL_KEYDOWN:
switch (event.key.keysym.sym){
case SDLK_TAB:hif_toshowmap=1;break;
case SDLK_UP:hif_keys_pressed[0]=1;break;
case SDLK_RIGHT:hif_keys_pressed[1]=1;break;
case SDLK_DOWN:hif_keys_pressed[2]=1;break;
case SDLK_LEFT:hif_keys_pressed[3]=1;break;
case SDLK_SPACE:if (hif_player_info.size!=3){hif_keys_pressed[4]=1;SND_PlayWave(0,0);};hif_player_info.oldsize=hif_player_info.size;
  if (hif_player_info.weapon==0){hif_proceed_chsize(3);};break;
case SDLK_LCTRL:case SDLK_RCTRL:if (hif_player_info.size!=3)hif_proceed_opendoor();break;
case SDLK_LALT:case SDLK_RALT:hif_keys_pressed[5]=1;break;
case SDLK_1:case SDLK_2:case SDLK_3:case SDLK_4:case SDLK_5:case SDLK_6:
if (hif_player_info.apanel_state==HIF_PANEL_HERE){i=event.key.keysym.sym-SDLK_1;if (hif_player_info.apanel_opts[i]==1){
if ((((i==1)||(i==2))&&(hif_player_info.num_prebeer==0))||((i==5)&&((hif_player_info.weapons[7]==0)||
        (hif_player_info.weapons[6]==0))))break;
switch (i){
case 1:case 2:hif_player_info.num_prebeer--;break;
case 5:hif_player_info.weapons[6]--;hif_player_info.weapons[7]--;break;
};
    hif_player_info.apanel_opts[event.key.keysym.sym-SDLK_1]=hif_apanel_times[event.key.keysym.sym-SDLK_1];};break;};
case SDLK_7:case SDLK_8:case SDLK_9:
  if (hif_player_info.weapons[event.key.keysym.sym-SDLK_1]!=0) {hif_player_info.weapon=event.key.keysym.sym-SDLK_1;};hif_to_update_panel=1;break;
case SDLK_LEFTBRACKET:
do {hif_player_info.weapon+=8;hif_player_info.weapon%=9;
}while(hif_player_info.weapons[hif_player_info.weapon]==0);hif_to_update_panel=1;break;
case SDLK_RIGHTBRACKET:
do {hif_player_info.weapon++;hif_player_info.weapon%=9;}while(hif_player_info.weapons[hif_player_info.weapon]==0);hif_to_update_panel=1;
break;
case SDLK_m:hif_proceed_explode();break;
case SDLK_EQUALS:if (hif_player_info.size!=3)hif_proceed_shootdot();break;
case SDLK_p:switch (hif_player_info.apanel_state){
  case HIF_PANEL_HERE:case HIF_PANEL_SHOWING:hif_player_info.apanel_state=HIF_PANEL_HIDING;
      hif_player_info.apanel_phase=HIF_PANEL_NUMPHASES;hif_player_info.apanel_pos=1;break;
  case HIF_PANEL_NONE:case HIF_PANEL_HIDING:hif_player_info.apanel_state=HIF_PANEL_SHOWING;
      hif_player_info.apanel_phase=HIF_PANEL_NUMPHASES;hif_player_info.apanel_pos=1;break;};break;
case SDLK_INSERT:hif_proceed_chsize(0);break;
case SDLK_DELETE:hif_proceed_chsize(1);break;
case SDLK_HOME:hif_proceed_chsize(2);break;
case SDLK_END:hif_proceed_chsize(3);break;
case SDLK_F12:show_fps=1-show_fps;break;
default:break;};break;
case SDL_KEYUP:
switch (event.key.keysym.sym){
case SDLK_TAB:hif_toshowmap=0;break;
case SDLK_ESCAPE:SDL_SemWait(hif_state.sem_refr_ready);SDL_SemPost(hif_state.sem_refr_ready);memset(hif_keys_pressed,0,5);i=gamemenu(1);
  switch (i){
  case GAMEMENU_QUIT:hif_stillplaying=0;break;
  case GAMEMENU_JUSTPLAY:break;
  case GAMEMENU_HELP:hif_help();break;
  default:hif_savesg(i-GAMEMENU_SAVEFIRST);};misc_getkeyboard();hif_lasttime2=SDL_GetTicks();break;
case SDLK_UP:hif_keys_pressed[0]=0;break;
case SDLK_RIGHT:hif_keys_pressed[1]=0;break;
case SDLK_DOWN:hif_keys_pressed[2]=0;break;
case SDLK_LEFT:hif_keys_pressed[3]=0;break;
case SDLK_SPACE:hif_keys_pressed[4]=0;hif_proceed_chsize(hif_player_info.oldsize);break;
case SDLK_LALT:case SDLK_RALT:hif_keys_pressed[5]=0;break;
case SDLK_s:savescreen();memset(hif_keys_pressed,0,5);misc_getkeyboard();break;
default:break;};break;
case SDL_QUIT:SDL_Quit();break;
};
//try to push button
#define HIF_PRESSBUTTON(x,y) if (hif_level_info.walls[(y)*hif_level_info.xsize+(x)]==10){hif_player_info.state=HIF_STATE_PRESSING;\
            hif_player_info.butt_x=x;hif_player_info.butt_y=y;hif_handler(HIF_LEVHAND_PREBUTTON,(y)*hif_level_info.xsize+(x),NULL,0,0);}
if ((hif_keys_pressed[5]==1)&&(hif_player_info.state==HIF_STATE_WALKING)){
HIF_PRESSBUTTON((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][1])/40);
if ((hif_player_info.y+hif_sizes[hif_player_info.size][1])/40!=(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40)
  HIF_PRESSBUTTON((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40);
if ((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40!=(hif_player_info.x+hif_sizes[hif_player_info.size][2])/40){
  HIF_PRESSBUTTON((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][1])/40);
  if ((hif_player_info.y+hif_sizes[hif_player_info.size][1])/40!=(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40)
    HIF_PRESSBUTTON((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40);};};
//try to shoot
log_block[2]=2;
if ((hif_player_info.size<2)&&(hif_keys_pressed[4]==1)&&(hif_player_info.shootdelay==0)&&
      (hif_player_info.weapons[hif_player_info.weapon]!=0)){
switch (hif_player_info.weapon){
case 1:case 2:case 3:case 4:case 5:case 6:case 7: if (hif_level_info.numthings<HIF_NUM_THINGS)
if (hif_proceed_can_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),hif_player_info.y+5)==0){
hif_register_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),hif_player_info.y+5,
  5*(2*hif_player_info.direction-1)+hif_keys_pressed[1]-hif_keys_pressed[3],hif_player_info.vy/3,1,HIF_THING_FIRSTSHELL+hif_player_info.weapon-1,
              (hif_player_info.weapon<6)?1:0,0);hif_player_info.weapons[hif_player_info.weapon]--;hif_to_update_panel=1;};break;
case 0:break;
case 8:if ((hif_player_info.weapons[8]>0)&&(hif_level_info.bee.enabled==0)&&
            (hif_proceed_bee_cango(hif_player_info.x,hif_player_info.y)==0)){
  hif_player_info.weapons[8]--;hif_level_info.bee.enabled=1;
  hif_level_info.bee.init(hif_player_info.x,hif_player_info.y);hif_to_update_panel=1;hif_player_info.t_drank=4*HIF_DRANK_QUATER-1;};break;};
 hif_player_info.shootdelay=hif_weapon_delays[8];};
if (hif_player_info.shootdelay!=0){hif_player_info.shootdelay--;};
//move hedgehog
if (hif_player_info.state==HIF_STATE_WALKING){
if (hif_keys_pressed[1]==1){hif_player_info.direction=1;if (hif_proceed_trytogo(HIF_VELOCITY,0)!=0){hif_proceed_trytogo(1,0);}else{
    HIF_CHANGE_HED_PHASE;};};
if (hif_keys_pressed[3]==1){hif_player_info.direction=0;if (hif_proceed_trytogo(-HIF_VELOCITY,0)!=0){hif_proceed_trytogo(-1,0);}else{
    HIF_CHANGE_HED_PHASE;};};
if (hif_keys_pressed[2]==1){if (hif_proceed_trytogo(0,HIF_VELOCITY)!=0){hif_proceed_trytogo(0,1);};};
};
//proceed things
log_block[2]=3;
for (i=0;i<hif_level_info.numthings;i++)if (hif_level_info.things[i].proceed()!=0)hif_unregister_thing(i--);
//normalize things array
log_block[2]=4;
i=i2=0;
while (i<hif_level_info.numthings)
  if ((((int)(hif_level_info.things[i].x/40))+((int)(hif_level_info.things[i].y/40))*(hif_level_info.xsize))==hif_level_info.things[i].cell)
    {hif_level_info.things[i2++]=hif_level_info.things[i++];}else{hif_level_info.things2[i-i2]=hif_level_info.things[i++];};
i3=hif_level_info.numthings-i2;hif_level_info.numthings=i2;
for (i=0;i<i3;i++)hif_register_thing(hif_level_info.things2[i].x,hif_level_info.things2[i].y,hif_level_info.things2[i].vx,hif_level_info.things2[i].vy,
                                hif_level_info.things2[i].no,hif_level_info.things2[i].type,hif_level_info.things2[i].is_hurting,hif_level_info.things2[i].is_lonely);
//build things map
hif_level_info.thing_map[0]=i=i2=0;//i - cell, i2 - thing
while (i2<hif_level_info.numthings){while(hif_level_info.things[i2].cell>i)hif_level_info.thing_map[++i]=i2;i2++;};
while (i<hif_level_info.xsize*hif_level_info.ysize)hif_level_info.thing_map[++i]=hif_level_info.numthings;
hif_level_info.thing_map_rest[0]=i=i2=0;//i - cell, i2 - thing
while (i2<hif_level_info.numthings_rest){while(hif_level_info.things_rest[i2].cell>i)hif_level_info.thing_map_rest[++i]=i2;i2++;};
while (i<hif_level_info.xsize*hif_level_info.ysize)hif_level_info.thing_map_rest[++i]=hif_level_info.numthings_rest;
//hedgehog gets resting things
{
int x1=(hif_player_info.x+hif_sizes[hif_player_info.size][0]-5)/40,y1=(hif_player_info.y+hif_sizes[hif_player_info.size][1]-5)/40,
     x2=(hif_player_info.x+hif_sizes[hif_player_info.size][2]+5)/40,y2=(hif_player_info.y+hif_sizes[hif_player_info.size][3]+5)/40,
      x0,y0,i;
if (x1<0)x1=0;if (x2>=hif_level_info.xsize)x2=hif_level_info.xsize-1;
if (y1<0)y1=0;if (y2>=hif_level_info.ysize)y2=hif_level_info.ysize-1;
for (x0=x1;x0<=x2;x0++)for (y0=y1;y0<=y2;y0++)
  for(i=hif_level_info.thing_map_rest[hif_level_info.xsize*y0+x0];i<hif_level_info.thing_map_rest[hif_level_info.xsize*y0+x0+1];i++)
    if(hif_level_info.things_rest[i].proceed()!=0)hif_level_info.things_rest[i].is_hurting=-1;
};
//proceed things between them
log_block[2]=5;
for (i=0;i<hif_level_info.xsize*hif_level_info.ysize;i++){
for (i2=hif_level_info.thing_map[i];i2<hif_level_info.thing_map[i+1];i2++)for (i3=i2+1;i3<hif_level_info.thing_map[i+1];i3++)
    hif_proceed_two_things(&(hif_level_info.things[i2]),&(hif_level_info.things[i3]));
for (i2=hif_level_info.thing_map[i];i2<hif_level_info.thing_map[i+1];i2++)
  for (i3=hif_level_info.thing_map_rest[i];i3<hif_level_info.thing_map_rest[i+1];i3++)
    hif_proceed_two_things(&(hif_level_info.things[i2]),&(hif_level_info.things_rest[i3]));
if (((i+1)%hif_level_info.xsize)!=0)hif_proceed_two_cells(i,i+1);
if ((i/hif_level_info.xsize)!=(hif_level_info.ysize-1))hif_proceed_two_cells(i,i+hif_level_info.xsize);
if ((((i+1)%hif_level_info.xsize)!=0)&&((i/hif_level_info.xsize)!=(hif_level_info.ysize-1)))hif_proceed_two_cells(i,i+hif_level_info.xsize+1);
if ((((i+1)%hif_level_info.xsize)!=0)&&(i>=hif_level_info.xsize))hif_proceed_two_cells(i,i-hif_level_info.xsize+1);
};
//delete some things
i=i2=0;
while (i<hif_level_info.numthings)if (hif_level_info.things[i].is_hurting<0){i++;}else{hif_level_info.things[i2++]=hif_level_info.things[i++];};
hif_level_info.numthings=i2;
i=i2=0;
while (i<hif_level_info.numthings_rest)if (hif_level_info.things_rest[i].is_hurting<0){i++;}else
        {hif_level_info.things_rest[i2++]=hif_level_info.things_rest[i++];};
hif_level_info.numthings_rest=i2;
//make resting/normal things in their arrays
i2=i3=0;//i2 - num innormal things, i3 - num normal
for (i=0;i<hif_level_info.numthings;i++)
  if ((hif_level_info.things[i].is_resting==1)&&(hif_level_info.things[i].vx==0)&&(hif_level_info.things[i].vy==0))
    {hif_level_info.things2[i2++]=hif_level_info.things[i];}else{hif_level_info.things[i3++]=hif_level_info.things[i];};hif_level_info.numthings=i3;
for (i=0;i<i2;i++)hif_register_thing_rest(hif_level_info.things2[i].x,hif_level_info.things2[i].y,hif_level_info.things2[i].vx,hif_level_info.things2[i].vy,
  hif_level_info.things2[i].no,hif_level_info.things2[i].type,hif_level_info.things2[i].is_hurting,hif_level_info.things2[i].is_lonely);
i2=i3=0;//i2 - num innormal things, i3 - num normal
for (i=0;i<hif_level_info.numthings_rest;i++)
  if ((hif_level_info.things_rest[i].is_resting==0)||(hif_level_info.things_rest[i].vx!=0)||(hif_level_info.things_rest[i].vy!=0)||
                                      (hif_level_info.things_rest[i].is_hurting!=0))
    {hif_level_info.things2[i2++]=hif_level_info.things_rest[i];}else{hif_level_info.things_rest[i3++]=hif_level_info.things_rest[i];};
      hif_level_info.numthings_rest=i3;
for (i=0;i<i2;i++)hif_register_thing(hif_level_info.things2[i].x,hif_level_info.things2[i].y,hif_level_info.things2[i].vx,hif_level_info.things2[i].vy,
  hif_level_info.things2[i].no,hif_level_info.things2[i].type,hif_level_info.things2[i].is_hurting,hif_level_info.things2[i].is_lonely);
//proceed drops
log_block[2]=6;
for (i=0;i<hif_level_info.numdrops;i++)hif_level_info.drops[i].proceed();
//proceed keepers
#define IN_KEEPER(q,w) hif_level_info.keepers[hif_level_info.xsize*((hif_player_info.y+hif_sizes[hif_player_info.size][q])/40)+ \
    ((hif_player_info.x+hif_sizes[hif_player_info.size][w])/40)]==1
hif_player_info.in_keeper=
  (((IN_KEEPER(0,1))||(IN_KEEPER(2,1))||(IN_KEEPER(0,3))||(IN_KEEPER(2,3)))&&(hif_player_info.size!=3))?(1):(0);
//proceed vents
log_block[2]=7;
hif_player_info.in_vent=0;
for (i=0;i<hif_level_info.numvents;i++)hif_level_info.vents[i].proceed();
hif_offs=hif_player_info.vent_offs;
hif_player_info.vent_offs=hif_offs%((hif_sizes[hif_player_info.size][2]-hif_sizes[hif_player_info.size][0])*
        (hif_sizes[hif_player_info.size][3]-hif_sizes[hif_player_info.size][1]));
hif_offs/=((hif_sizes[hif_player_info.size][2]-hif_sizes[hif_player_info.size][0])*
        (hif_sizes[hif_player_info.size][3]-hif_sizes[hif_player_info.size][1]));
if ((hif_player_info.vy>0)&&(hif_player_info.in_keeper==1))hif_player_info.vy--;
if (hif_player_info.in_keeper==0){
  if (hif_keys_pressed[0]==1){
    if (hif_proceed_cango(0,1)!=0){
      hif_player_info.vy=-30-((hif_player_info.size==3)?(10):(0));hif_offs-=2;}else{
      hif_offs+=hif_player_info.vy/3+3;};
    } else {hif_offs+=hif_player_info.vy/3+3;};} else {
  hif_offs=0;if (hif_keys_pressed[0]==1)hif_proceed_trytogo(0,-2);
  hif_player_info.vy=10*(hif_keys_pressed[2]-hif_keys_pressed[0])-20*hif_keys_pressed[0];};
i=0;
while ((hif_offs!=0)&&(i==0))
  {if (hif_proceed_trytogo(0,SGN(hif_offs))!=0){i=1;if (hif_player_info.in_vent==1){hif_player_info.vy=0;};}else{hif_offs-=SGN(hif_offs);};};
if (i==1){
if (hif_player_info.in_vent==0){hif_player_info.vy=(int)(-hif_player_info.vy/HIF_JUMP_KOEF);};
}else{
hif_player_info.vy++;
};
//proceed rivers
log_block[2]=8;
hif_player_info.in_river=0;
for (i=0;i<hif_level_info.numrivers;i++)hif_level_info.rivers[i].proceed();
hif_offs=hif_player_info.river_offs;
hif_player_info.river_offs=hif_offs%((hif_sizes[hif_player_info.size][3]-hif_sizes[hif_player_info.size][1])*
        (hif_sizes[hif_player_info.size][2]-hif_sizes[hif_player_info.size][0]));
hif_offs/=((hif_sizes[hif_player_info.size][3]-hif_sizes[hif_player_info.size][1])*
        (hif_sizes[hif_player_info.size][2]-hif_sizes[hif_player_info.size][0]));
if (hif_proceed_trytogo(hif_offs,0)!=0){hif_proceed_trytogo(SGN(hif_offs),0);};
if (hif_player_info.in_river==1){if (hif_player_info.air>0){hif_player_info.air--;}
  else{if (hif_ticks%5==0){hif_player_info.health--;hif_updatepanel();};};}
    else{hif_player_info.air+=10;if (hif_player_info.air>1000)hif_player_info.air=1000;};
if ((hif_player_info.in_river==1)&&(hif_ticks%20==0)&&(hif_level_info.numair<HIF_NUM_AIR)){
  hif_level_info.air[hif_level_info.numair++].init(hif_player_info.x+(2*hif_player_info.direction-1)*hif_nose[hif_player_info.size][0],
          hif_player_info.y+hif_nose[hif_player_info.size][1]-5);};
//proceed cells, where hedgehog is placed
log_block[2]=9;
hif_proceed_cell((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][1])/40);
if (((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40)!=((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40))
  hif_proceed_cell((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][1])/40);
if (((hif_player_info.y+hif_sizes[hif_player_info.size][1])/40)!=((hif_player_info.y+hif_sizes[hif_player_info.size][3])/40)){
hif_proceed_cell((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40);
if (((hif_player_info.x+hif_sizes[hif_player_info.size][0])/40)!=((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40))
  hif_proceed_cell((hif_player_info.x+hif_sizes[hif_player_info.size][2])/40,(hif_player_info.y+hif_sizes[hif_player_info.size][3])/40);};
//proceed bee
log_block[2]=10;
hif_level_info.bee.proceed();
//proceed colour lines
log_block[2]=11;
for (i=0;i<hif_level_info.numlines;i++)if (hif_level_info.lines[i].proceed()==-1)
    {hif_level_info.lines[i]=hif_level_info.lines[hif_level_info.numlines-1];hif_level_info.numlines--;};
//proceed enemies
log_block[2]=12;
for (i=0;i<hif_level_info.numenemies;i++)hif_level_info.enemies[i]->all_proceed();
//proceed air
log_block[2]=13;
for (i=0;i<hif_level_info.numair;i++)if (hif_level_info.air[i].proceed()!=0)hif_level_info.air[i--]=hif_level_info.air[--hif_level_info.numair];
//proceed fireballs
log_block[2]=14;
for (i=0;i<hif_level_info.numfireballs;i++){if (hif_level_info.fireballs[i].proceed()==-1)
                              {hif_level_info.fireballs[i]=hif_level_info.fireballs[hif_level_info.numfireballs-1];hif_level_info.numfireballs--;i--;};};
//proceed blocks
log_block[2]=15;
for (i=0;i<hif_level_info.numblocks;i++)hif_level_info.blocks[i].proceed();
//proceed apanel
log_block[2]=16;
switch (hif_player_info.apanel_state){
case HIF_PANEL_SHOWING:if ((hif_player_info.apanel_phase--)==0)hif_player_info.apanel_state=HIF_PANEL_HERE;
      hif_player_info.apanel_pos/=HIF_PANEL_KOEF;break;
case HIF_PANEL_HIDING:if ((hif_player_info.apanel_phase--)==0)hif_player_info.apanel_state=HIF_PANEL_NONE;
      hif_player_info.apanel_pos/=HIF_PANEL_KOEF;break;
case HIF_PANEL_HERE:case HIF_PANEL_NONE:break;
};
for (i=0;i<6;i++)if (hif_player_info.apanel_opts[i]>1)if ((--hif_player_info.apanel_opts[i])==1)switch(i){
case 0:hif_proceed_catchshells(0);break;
case 1:hif_player_info.weapons[8]++;hif_to_update_panel=1;break;
case 2:hif_player_info.health+=HIF_BEER_HEALTH;hif_player_info.t_drank+=100;hif_to_update_panel=1;break;
case 3:hif_player_info.vy=-60;break;
case 4:hif_proceed_catchshells(1);break;
case 5:if ((hif_level_info.numthings<HIF_NUM_THINGS)&&(hif_proceed_can_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),
                                hif_player_info.y+5)==0)){
hif_register_thing(hif_player_info.x+25*(2*hif_player_info.direction-1),hif_player_info.y+5,
      5*(2*hif_player_info.direction-1)+hif_keys_pressed[1]-hif_keys_pressed[3],0,1,HIF_THING_TRAPMINE,0,0);}else
  {hif_player_info.weapons[6]++;hif_player_info.weapons[7]++;}break;
};
if ((hif_player_info.apanel_opts[3]>1)&&(hif_proceed_cango(0,1)==0)&&(hif_player_info.in_keeper==0))hif_player_info.apanel_opts[3]=1;
//proceed scored things
log_block[2]=18;
for (i=0;i<hif_level_info.numscth;i++)if (hif_level_info.scth[i].proceed()==-1)hif_level_info.scth[i--]=hif_level_info.scth[--hif_level_info.numscth];
//proceed using level handler
log_block[2]=19;
hif_handler(HIF_LEVHAND_PROCIDLE,0,NULL,0,0);
//
/*if (hif_level==1){
int x=rand()%(40*hif_level_info.xsize-40)+20,y=rand()%(40*hif_level_info.ysize-40)+20;
if(hif_ticks%6==0)if (hif_proceed_can_thing(x,y)==0)hif_register_thing(x,y,0,0,1,HIF_THING_FIRSTSHELL,0);
if (hif_level_info.numthings<2000)
  {hif_player_info.x=rand()%(40*hif_level_info.xsize-40)+20;hif_player_info.y=rand()%(40*hif_level_info.xsize-40)+20;}else{
    if (hif_level_info.numthings==2000){hif_player_info.x=hif_player_info.y=80;};};
};*/
//if ((hif_level_info.numthings<1000)&&(hif_level==0))hif_register_thing(400,240,0,0,1,HIF_THING_FIRSTSHELL+rand()%4,0);
//if health<=0 - quit procedure
log_block[2]=21;
if (hif_player_info.health<=0){showvideo(VIDEO_GAMEOVER);hif_stillplaying=0;what_to_do=WHAT_FIRSTLEVEL;};
}
