#include "sg.h"
#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>
#include "images.h"
#include <stdlib.h>
#include <time.h>
#include "misc.h"
#include "video.h"
#include <bzlib.h>
#include "sound.h"
#include "log.h"
#include "locale.h"
SDL_Surface *screen;
int level_finished=0,what_to_do=WHAT_FIRSTLEVEL;
char *homedir=NULL;
void showvideo(int no);
void ll(int save_no);
void hif(int save_no);
void hw(int save_no);
void load_cfg(void);
void save_cfg(void);
int gamemenu_exit(int menu_type);
//SDL_Surface *fps_surf;
void HIF_GRAPHICS_Done(void);
int main(void)
{
SDL_VideoInfo *vid_info;
LOG_Init();
fprintf(LOG,"\"Crazy Hendehoh\", file %s compiled %s, %s\n",__FILE__,__DATE__,__TIME__);
log_block[0]=LOG_INIT;log_block[1]=0;
//init SDL
if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_AUDIO)<0){fprintf(LOG,"Could not init SDL: %s\n",SDL_GetError());exit(1);};
log_block[1]=1;
//load config file
load_cfg();
//load locale
log_block[1]=2;
LOCALE_Init();
//initialize everything
srand(time(0)%65535);
if ((screen=SDL_SetVideoMode(640,480,32,screen_flags))==NULL)
    {fprintf(LOG,"Could not set 640x480xTrue colour or something like it\n");SDL_Quit();exit(1);};
if (!(screen_flags&SDL_FULLSCREEN)){char *a,*b;SDL_WM_GetCaption(&a,&b);SDL_WM_SetCaption("Crazy Hendehoh by Sunny Hendehoh",b);};
vid_info=(SDL_VideoInfo*)SDL_GetVideoInfo();
#define YESNO(t) (((t)==0)?(" not"):(""))
fprintf(LOG,"Inited video: hw surfaces%s available, hwCC blits%s accelerated, color fills%s accelerated, %i KB video memory.\n",
  YESNO(vid_info->hw_available),YESNO(vid_info->blit_hw_CC),YESNO(vid_info->blit_fill),vid_info->video_mem);
log_block[1]=3;
SDL_WarpMouse(0,0);
IMAGES_Init();
log_block[1]=4;
SND_Init();
log_block[1]=5;
SND_LoadExtraMusic();
log_block[1]=6;
SMFONT_Init();
log_block[1]=7;
//fps_surf=SDL_CreateRGBSurface(SDL_HWSURFACE,2000,500,32,SURFACE_COLOURS);
//SDL_FillRect(fps_surf,NULL,C_BLACK(fps_surf));
log_block[1]=8;
video_init();
//main loop
while (what_to_do!=WHAT_QUIT){
fprintf(LOG,"Main cycle (main.c): parm %i\n",what_to_do);
 //show final video?
if (what_to_do==WHAT_FINAL){showvideo(VIDEO_FINAL);what_to_do=WHAT_FIRSTLEVEL;};
if (what_to_do<NUM_OF_SG){
 //load saved game?
SAVE_REC rec;
BZFILE *f;
SGname[SGOFFSET]=what_to_do/10+'0';
SGname[SGOFFSET+1]=what_to_do%10+'0';
if ((f=BZ2_bzopen(SGname,"r"))!=NULL){
if (BZ2_bzread(f,&rec,sizeof(rec))==sizeof(rec)){
BZ2_bzclose(f);
if (rec.episode_no==0){hif(what_to_do);}else{
if (rec.episode_no==1){hw(what_to_do);}else{ll(what_to_do);};};
} else {BZ2_bzclose(f);misc_fail("SG error");what_to_do=WHAT_FIRSTLEVEL;};} else {misc_fail("SG error");what_to_do=WHAT_FIRSTLEVEL;};
}else{
 //run one of the episodes ?
if (what_to_do==WHAT_FIRSTLEVEL){hif(what_to_do);}else{
if (what_to_do==WHAT_FIRSTLEVEL+1){hw(what_to_do);}else{ll(what_to_do);};
};};};
//uninitialize everything
log_block[0]=LOG_DONE;log_block[1]=0;
video_done();
SND_Done();
log_block[1]=1;
IMAGES_Done();
log_block[1]=2;
//SDL_SaveBMP(fps_surf,"fps.bmp");
//SDL_FreeSurface(fps_surf);
HIF_GRAPHICS_Done();
SDL_Quit();
log_block[1]=3;
fprintf(LOG,"SDL_Quit successfull.\n");
//save config file
save_cfg();
log_block[1]=4;
LOG_Done();
return 0;
}
