#include "log.h"
#include <SDL/SDL.h>
#include "images.h"
#include "sound.h"
#include "sg.h"
#include <bzlib.h>
#include <string.h>
#include <stdlib.h>
#include "locale.h"
#define MAX_CMD_SIZE 25
#define MAX_PARM_SIZE 25
#define BUFFER_SIZE 1000
#define PARSER_UINT8 0
#define PARSER_STRING 1
#define PARSER_MUSICSTRING 2
typedef void (MUSICFUNC) (void);
static char buffer[BUFFER_SIZE],*cfgtemp,*cfgtemp_start,adrv[MAX_PARM_SIZE]="default",vdrv[MAX_PARM_SIZE]="default",cfgname[80];
static Uint8 is_full,is_hw;
Uint32 screen_flags;
typedef struct {char type;char name[MAX_CMD_SIZE];void *var;MUSICFUNC *handler;Uint8 min,max;} parser_var;
#define PARSER_NUMVARS 9
static char got_vars[PARSER_NUMVARS];
//Note: if there is a variable with the name that is the same as the start of the other variable's name (as example, "volume" and "volume_music"),
//the longer one must be the first.
//30 variables max!
static const parser_var parser_vars[PARSER_NUMVARS]={
  {PARSER_UINT8,"music_volume",&SND_MUS_volume,NULL,0,127},
  {PARSER_UINT8,"sound_volume",&SND_WAV_volume,NULL,0,127},
  {PARSER_UINT8,"fps",&fps,NULL,10,100},
  {PARSER_STRING,"video_driver",&vdrv,NULL,0,25},
  {PARSER_STRING,"audio_driver",&adrv,NULL,0,25},
  {PARSER_UINT8,"is_fullscreen",&is_full,NULL,0,1},
  {PARSER_UINT8,"is_hardware",&is_hw,NULL,0,1},
  {PARSER_MUSICSTRING,"AddMusic",&SND_musicname,&SND_AddMusic,0,SND_MUSICNAMESIZE},
  {PARSER_STRING,"locale",&locale_name,NULL,0,LOCALENAMESIZE}};
#define FINISH_STRING if (still_working==1){*cfgtemp++=0;}
static void parser_readstring(char still_working)
{
#define FAIL_VAR(n) {fprintf(LOG,"Error reading variable %s in %s. %s\n",parser_vars[i].name,cfgname,n);exit(1);}
char *c=&(buffer[0]),i,*c2;
Uint8 t;
while (*c==' ')c++;if (*c==0){FINISH_STRING;return;};
if (*c=='#'){while (*c!=0)*cfgtemp++=*c++;FINISH_STRING;return;};
for (i=0;i<PARSER_NUMVARS;i++)if (strncmp(c,parser_vars[i].name,strlen(parser_vars[i].name))==0)break;
if (i==PARSER_NUMVARS){fprintf(LOG,"Unknown variable. String %s\n",c);exit(1);};got_vars[i]++;*cfgtemp++=i+1;
c+=strlen(parser_vars[i].name);if (*c!=' ')FAIL_VAR("No space after variable name.");while (*c==' ')c++;
switch (parser_vars[i].type){
case PARSER_MUSICSTRING:case PARSER_STRING:if (*c!='\"')FAIL_VAR("No \'\"\' found");c2=(char *)parser_vars[i].var;c++;
  if (parser_vars[i].type==PARSER_MUSICSTRING){char *_c=(char *)parser_vars[i].name;while (*_c!=0)*cfgtemp++=*_c++;*cfgtemp++=' ';
    *cfgtemp++='\"';};
  while (((c2-(char *)parser_vars[i].var)<=parser_vars[i].max)&&(*c!='\"'))
    {if (parser_vars[i].type==PARSER_MUSICSTRING)*cfgtemp++=*c;*c2++=*c++;};
  if (*c++!='\"')FAIL_VAR("Too long parameter.");*c2=0;
  if (parser_vars[i].type==PARSER_MUSICSTRING){*cfgtemp++='\"';parser_vars[i].handler();};
break;
case PARSER_UINT8:if ((*c<'0')||(*c>'9'))FAIL_VAR("Strange digit.");t=(*c++)-'0';
  if ((*c!=' ')&&(*c!=0)){if ((*c<'0')||(*c>'9'))FAIL_VAR("Strange digit.");t=t*10+((*c++)-'0');
  if ((*c!=' ')&&(*c!=0)){if ((*c<'0')||(*c>'9'))FAIL_VAR("Strange digit.");
  if ((t>25)||((t==25)&&(*c++>'5')))FAIL_VAR("Too big number");t=t*10+((*c++)-'0');};};
  if ((*c!=' ')&&(*c!=0))FAIL_VAR("Strange digit.");
  if (t>parser_vars[i].max){
    fprintf(LOG,"Error reading variable %s in %s. It is %i with maximum %i\n",parser_vars[i].name,cfgname,t,parser_vars[i].max);exit(1);};
  *(Uint8 *)(parser_vars[i].var)=t;break;
default:FAIL_VAR("Unknown variable type");
};
while (*c!=0)*cfgtemp++=*c++;FINISH_STRING;
}
void load_cfg(void)
{
FILE *cfgfile;
BZFILE *cfg_orig;
char stillparsing=1,i,*buf;
memset(got_vars,0,sizeof(got_vars));
if (homedir==NULL){sprintf(cfgname,"game.cfg");}else{sprintf(cfgname,"%s/.hendehoh/config",homedir);};
if ((cfgfile=fopen(cfgname,"r"))==NULL){
if ((cfg_orig=BZ2_bzopen("stuff/cfg.bz2","r"))==NULL){fprintf(LOG,"stuff/cfg.bz2 not found - giving up parse.\n");SDL_Quit();exit(1);};
if ((cfgfile=fopen(cfgname,"w"))==NULL){fprintf(LOG,"Could not open %s for write - giving up parse.\n",cfgname);SDL_Quit();exit(1);};
while (BZ2_bzread(cfg_orig,&i,1)==1)fwrite(&i,1,1,cfgfile);
fclose(cfgfile);BZ2_bzclose(cfg_orig);fprintf(LOG,"New config file created - edit it, please.\n");
if ((cfgfile=fopen(cfgname,"r"))==NULL){fprintf(LOG,"Could not open %s to read - strange... Giving up parse.\n",cfgname);SDL_Quit();exit(1);};
};
fseek(cfgfile,0,SEEK_END);cfgtemp=cfgtemp_start=(char *)malloc(ftell(cfgfile));fseek(cfgfile,0,SEEK_SET);
while (stillparsing==1){
  buf=&(buffer[0]);
  do {if (fread(&i,1,1,cfgfile)==0){stillparsing=0;i=0xa;break;};if (i>=32)*buf++=i;}while((i!=0xa)&&(buf!=&(buffer[BUFFER_SIZE-1])));
  *buf=0;parser_readstring(stillparsing);
  };
fclose(cfgfile);
stillparsing=1;
for (i=0;i<PARSER_NUMVARS;i++)if ((got_vars[i]!=1)&&(parser_vars[i].type!=PARSER_MUSICSTRING)){stillparsing=0;
    fprintf(LOG,(got_vars[i]==0)?("Error in %s : variable not defined: %s\n"):("Error in %s : variable defined twice: %s\n"),cfgname,parser_vars[i].name);};
if (stillparsing==0){SDL_Quit();exit(1);};
fprintf(LOG,"Config file %s parsed OK. Got such variables:\n",cfgname);
for (i=0;i<PARSER_NUMVARS;i++)if (parser_vars[i].type!=PARSER_MUSICSTRING){fprintf(LOG,"     %s ",parser_vars[i].name);
  switch (parser_vars[i].type){
  case PARSER_UINT8:fprintf(LOG,"%i\n",*((Uint8*)parser_vars[i].var));break;
  case PARSER_STRING:fprintf(LOG,"%s\n",(char*)parser_vars[i].var);break;};};
if (strncmp("default",vdrv,MAX_PARM_SIZE)!=0){fprintf(LOG,"Initialising video driver %s -",vdrv);
    if (SDL_VideoInit(vdrv,0)<0){fprintf(LOG,"Could not set video driver %s: %s\n",vdrv,SDL_GetError());} else {fprintf(LOG,"OK\n");};};
if (strncmp("default",adrv,MAX_PARM_SIZE)!=0){fprintf(LOG,"Initialising audio driver %s -",adrv);
    if (SDL_AudioInit(adrv)<0){fprintf(LOG,"Could not set audio driver %s: %s\n",adrv,SDL_GetError());} else {fprintf(LOG,"OK\n");};};
screen_flags=(is_full*SDL_FULLSCREEN)|(is_hw*((SDL_HWSURFACE)|(SDL_DOUBLEBUF)));
}
void save_cfg(void)
{
FILE *cfg;
char *cfg_finish;
if ((cfg=fopen(cfgname,"w"))==NULL){fprintf(LOG,"Error opening %s for write.\n",cfgname);return;};
cfg_finish=cfgtemp;
cfgtemp=cfgtemp_start;
while (cfgtemp!=cfg_finish){
if ((unsigned char)*cfgtemp<0xa){
  if (*cfgtemp==0){fprintf(cfg,"\n");}else{
    switch (parser_vars[*cfgtemp-1].type){
    case PARSER_UINT8:fprintf(cfg,"%s %i",parser_vars[*cfgtemp-1].name,*((Uint8*)(parser_vars[*cfgtemp-1].var)));break;
    case PARSER_STRING:fprintf(cfg,"%s \"%s\"",parser_vars[*cfgtemp-1].name,(char*)parser_vars[*cfgtemp-1].var);break;
    };
  };
} else fwrite(cfgtemp,1,1,cfg);
cfgtemp++;
};
free(cfgtemp_start);fclose(cfg);fprintf(LOG,"Config saved successfully.\n");
}
