#include "images.h"
#include <math.h>
#include <SDL/SDL.h>
#include <stdlib.h>
#include "log.h"
#define TICKS_PER_FRAME 250
#define NUM_SOURCES 50
#define NUM_FRAMES 20
#define MAX_AMPL 300
#define MIN_AMPL 30
#define KOEF 0.06
#define SQR(a) ((a)*(a))
#define CELLSIZE 5
char type2=0;
void savescreen(void)
{
struct INT_Source {int x,y,ampl;float phase;};
struct INT_Source sources[NUM_SOURCES];
struct INT_Dot {int x,y;};
struct INT_Dot dots[2][CELLSIZE*CELLSIZE];
int i,pix=0,cur_frame=0,i2,toquit=0,i3;
SDL_Surface *frames[NUM_FRAMES*3];
Uint8 col_table[480][640][3];
SDL_Event event;
Uint32 ticks;
fprintf(LOG,"ScreenSaver.\n");
SDL_LockSurface(screen);
for (i=0;i<480;i++)for (i2=0;i2<640;i2++)
    SDL_GetRGB(*((Uint32*)((Uint8*)screen->pixels+i*screen->pitch+i2*4)),screen->format,&(col_table[i][i2][0]),&(col_table[i][i2][1]),
          &(col_table[i][i2][2]));
SDL_UnlockSurface(screen);
for (i=0;i<NUM_FRAMES*3;i++)if ((frames[i]=SDL_CreateRGBSurface(SDL_RLEACCEL|SDL_HWSURFACE,640,480,32,SURFACE_COLOURS))==NULL)
  {fprintf(LOG,"Error creating frame.\n");for (i3=0;i3<i;i3++)SDL_FreeSurface(frames[i3]);
    return;}else{SDL_FillRect(frames[i],NULL,SDL_MapRGB(frames[i]->format,0,0,0));SDL_LockSurface(frames[i]);};
for (i=0;i<NUM_SOURCES;i++){sources[i].x=rand()%640;sources[i].y=rand()%480;
      sources[i].ampl=rand()%(MAX_AMPL-MIN_AMPL+1)+MIN_AMPL;sources[i].phase=rand();
      sources[i].phase/=(float)RAND_MAX;sources[i].phase*=6.28;};
for (i=0;i<CELLSIZE;i++)for (i2=0;i2<CELLSIZE;i2++){dots[0][CELLSIZE*i+i2].x=i;dots[0][CELLSIZE*i+i2].y=i2;};
for (i=0;i<CELLSIZE*CELLSIZE;i++){i2=rand()%(CELLSIZE*CELLSIZE-i);
  dots[1][i]=dots[0][i2];dots[0][i2]=dots[0][CELLSIZE*CELLSIZE-1-i];
};
ticks=SDL_GetTicks();
while (toquit==0){

if (pix!=640*480)SDL_UnlockSurface(frames[cur_frame]);
SDL_BlitSurface(frames[cur_frame],NULL,screen,NULL);
if (pix!=640*480)SDL_LockSurface(frames[cur_frame]);
cur_frame++;cur_frame%=(NUM_FRAMES*3);
SDL_Flip(screen);
while (SDL_PollEvent(&event))if (event.type==SDL_KEYDOWN){toquit=1;SDL_PushEvent(&event);break;};

if (pix<640*480)while ((SDL_GetTicks()<ticks+TICKS_PER_FRAME)&&(pix<640*480)){
  int x=(pix%(640/CELLSIZE))*CELLSIZE,y=((pix/(640/CELLSIZE))*CELLSIZE)%480;
  float si_=0,co_=0,f=0;
  x+=dots[1][pix/(640*480/CELLSIZE/CELLSIZE)].x;
  y+=dots[1][pix/(640*480/CELLSIZE/CELLSIZE)].y;
  if ((col_table[y][x][0]!=0)||(col_table[y][x][1]!=0)||(col_table[y][x][2]!=0)){
  for (i3=0;i3<NUM_SOURCES;i3++)
    {
      si_+=sources[i3].ampl*sin(KOEF*sqrt(SQR(sources[i3].x-x)+SQR(sources[i3].y-y))+sources[i3].phase);
      co_+=sources[i3].ampl*cos(KOEF*sqrt(SQR(sources[i3].x-x)+SQR(sources[i3].y-y))+sources[i3].phase);
    };
  for (i2=0;i2<NUM_FRAMES*3;i2++){
    float k1=1-(float)(i2%NUM_FRAMES)/(float)(NUM_FRAMES),k2=1-k1;
    f=1-(si_*cos(i2*6.28/(NUM_FRAMES*3))-co_*sin(i2*6.28/(NUM_FRAMES*3)))/256.0;
if (type2==1){while (f<0)f+=1;while (f>1)f-=1;}else{while ((f<0)||(f>1))if (f<0){f=-f;}else{f=2-f;};};
    *((Uint32*)(((Uint8*)frames[i2]->pixels)+y*frames[i2]->pitch+4*x))=SDL_MapRGB(frames[i2]->format,
  (int)((col_table[y][x][((i2/NUM_FRAMES)+0)%3]*k1+col_table[y][x][((i2/NUM_FRAMES)+1)%3]*k2)*f),
  (int)((col_table[y][x][((i2/NUM_FRAMES)+1)%3]*k1+col_table[y][x][((i2/NUM_FRAMES)+2)%3]*k2)*f),
  (int)((col_table[y][x][((i2/NUM_FRAMES)+2)%3]*k1+col_table[y][x][((i2/NUM_FRAMES)+0)%3]*k2)*f));
    };
  };
if (++pix==640*480)for(i=0;i<NUM_FRAMES*3;i++)SDL_UnlockSurface(frames[i]);
};
ticks+=TICKS_PER_FRAME;
};
for (i=0;i<NUM_FRAMES*3;i++)if (i%2){
static char n[]="01.bmp";
n[0]=i/10+'0';n[1]=i%10+'0';
SDL_SaveBMP(frames[i],n);
};
for (i=0;i<NUM_FRAMES*3;i++)SDL_FreeSurface(frames[i]);
type2=1-type2;
}
