#include "log.h"
#include "sound.h"
#include <stdlib.h>
#include <string.h>
#define CHUNKSIZE 512
#define NUM_MUSICS 1
#define NUM_SOUNDS 4
static Mix_Chunk *SND_Waves[NUM_SOUNDS];
static Mix_Music *SND_Musics[NUM_MUSICS];
char SND_enabled=0;
static Sint8 SND_priorities[4];
Uint8 SND_WAV_volume=63,SND_MUS_volume=63,SND_MUS_chan;
char SND_musicname[SND_MUSICNAMESIZE];
SND_EXTRAMUSIC SND_extramusic[NUM_EXTRA_MUSICS];
char num_extramusics=0;
void SND_Init(void)
{
static const char WAV_Names[NUM_SOUNDS][40]={"sound/1.wav","sound/bee_breathing.wav","sound/bee_st_falling.wav","sound/bee_thinking.wav"};
static const char MUS_Names[NUM_MUSICS][40]={"sound/1.mod"};
int i;
if (Mix_OpenAudio(22050,AUDIO_S16,2,CHUNKSIZE)<0){fprintf(LOG,"Error opening sound: %s\n",SDL_GetError());return;}else{SND_enabled=1;};
for (i=0;i<NUM_SOUNDS;i++)if ((SND_Waves[i]=Mix_LoadWAV(WAV_Names[i]))==NULL)
    {fprintf(LOG,"Cound not load %s:%s\n",WAV_Names[i],SDL_GetError());SND_Waves[i]=NULL;};
for (i=0;i<NUM_MUSICS;i++)if ((SND_Musics[i]=Mix_LoadMUS(MUS_Names[i]))==NULL)
    {fprintf(LOG,"Cound not load %s:%s\n",MUS_Names[i],SDL_GetError());SND_Musics[i]=NULL;};
Mix_HaltMusic();
for (i=0;i<4;i++)Mix_HaltChannel(i);
SND_enabled=1;SND_SetWVolume();SND_SetMVolume();
}
void SND_SetMusic(int no)
{
if (SND_enabled==1){
Mix_HaltMusic();
if ((no>=0)&&(no<NUM_MUSICS))if(SND_Musics[no]!=NULL)
  {SND_MUS_chan=Mix_PlayMusic(SND_Musics[no],-1);Mix_Volume(SND_MUS_chan,SND_WAV_volume);};};
}
void SND_StopMusic(void)
{
if (SND_enabled==1){Mix_HaltMusic();};
}
void SND_PlayWave(int no,Sint8 priority)
{
int i,a=0;
if (SND_enabled==1){
for (i=0;i<4;i++)if (Mix_Playing(i)==0)
  if (SND_Waves[i]!=NULL){Mix_PlayChannel(i,SND_Waves[no],0);SND_priorities[i]=priority;return;};
for (i=1;i<4;i++)if(SND_priorities[i]<SND_priorities[a])a=i;
if(SND_priorities[a]<priority){Mix_HaltChannel(a);Mix_PlayChannel(a,SND_Waves[no],0);SND_priorities[a]=priority;};
};
}
void SND_Done(void)
{
int i;
if (SND_enabled==1){
for (i=0;i<NUM_SOUNDS;i++)Mix_FreeChunk(SND_Waves[i]);
for (i=0;i<NUM_MUSICS;i++)Mix_FreeMusic(SND_Musics[i]);
Mix_CloseAudio();fprintf(LOG,"Sound was uninitialised.\n");
}else{fprintf(LOG,"No sound - nothing no uninit.\n");};
}
void SND_SetMVolume(void)
{
if (SND_enabled==1){Mix_VolumeMusic(SND_MUS_volume);};
}
void SND_SetWVolume(void)
{
int t;
if (SND_enabled==1)for (t=0;t<4;t++)if (t!=SND_MUS_chan)Mix_Volume(t,SND_MUS_volume);
}
void SND_AddMusic(void)
{
if (num_extramusics==NUM_EXTRA_MUSICS){fprintf(LOG,"Cannot add music name %s - array full.\n",SND_musicname);return;};
strcpy(SND_extramusic[num_extramusics++].name,SND_musicname);
fprintf(LOG,"Adding music name: %s\n",SND_musicname);
}
void SND_LoadExtraMusic(void)
{
int i;
if (SND_enabled==1){
for (i=0;i<num_extramusics;i++){fprintf(LOG,"Loading extra music %s -",SND_extramusic[i].name);
  fprintf(LOG,"%s.\n",(((SND_extramusic[i].music=Mix_LoadMUS(SND_extramusic[i].name))==NULL)?("failed"):("OK")));
  if (SND_extramusic[i].music==NULL)SND_extramusic[i--]=SND_extramusic[--num_extramusics];
};} else {fprintf(LOG,"No sound - extra musics are not loaded.\n");};
}
static int extra_no=0;
void SND_PlayExtraMusic(void)
{
if (num_extramusics==0)return;
if (SND_enabled==1){extra_no++;extra_no%=num_extramusics;
Mix_HaltMusic();
Mix_HookMusicFinished(SND_PlayExtraMusic);
SND_MUS_chan=Mix_PlayMusic(SND_extramusic[extra_no].music,0);Mix_Volume(SND_MUS_chan,SND_WAV_volume);};
}
void SND_SetExtraMusic(int no)
{
extra_no=no-1;SND_PlayExtraMusic();
}
